// ComboBar.cpp : implementation file
//

#include "stdafx.h"
#include "MainFrm.h"
#include "ComboBar.h"
#include "zbrres.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CComboToolBar

CComboToolBar::CComboToolBar()
{
	m_btnOK.m_hWnd = NULL;
}

CComboToolBar::~CComboToolBar()
{
}


BEGIN_MESSAGE_MAP(CComboToolBar, CToolBar)
	//{{AFX_MSG_MAP(CComboToolBar)
	ON_WM_SETFOCUS()
	//}}AFX_MSG_MAP
	ON_CONTROL(CBN_SELENDOK, IDC_PATHCOMBO, OnSelectEndOk)

END_MESSAGE_MAP()


BOOL CComboToolBar::CreateComboBox(int nIndex, UINT nID, int width, int height)
{
	SetButtonInfo(nIndex, nID, TBBS_SEPARATOR, width);
	CRect rect;
	GetItemRect(CommandToIndex(nID), &rect);
	rect.bottom = rect.top + height;
	return m_combo.Create(CBS_DROPDOWN|WS_VISIBLE|WS_TABSTOP|WS_VSCROLL|CBS_AUTOHSCROLL, rect, this, nID);
}

BOOL CComboToolBar::CreatePushButton(int nIndex, UINT nID, int width)
{
	CToolBarCtrl& toolbar = GetToolBarCtrl();

	int nCount = toolbar.GetButtonCount();
	if(nIndex >= nCount) {
		TBBUTTON tb;
		ZeroMem(tb);
		tb.fsStyle = TBSTYLE_SEP;
		toolbar.AddButtons(nIndex - nCount + 1, &tb);
	}
	SetButtonInfo(nIndex, nID, TBBS_SEPARATOR, width);
	CRect rect;
	GetItemRect(CommandToIndex(nID), &rect);
//	rect.bottom = rect.top + height;
	if(!m_btnOK.Create(_T("OK"), BS_PUSHBUTTON|WS_VISIBLE|WS_CHILD, rect, this, nID))
		return FALSE;
	m_btnOK.SetFont(&m_combo.m_font);
	return TRUE;
}

void CComboToolBar::ResizeComboBox(int nIndex, UINT nID, int width)
{
	SetButtonInfo(nIndex, nID, TBBS_SEPARATOR, width);
	CRect rect;
	m_combo.GetClientRect(rect);
	rect.right = rect.left + width;
	m_combo.MoveWindow(rect);
	GetMainFrame()->RecalcLayout();
}

/////////////////////////////////////////////////////////////////////////////
// CComboToolBar message handlers

BOOL CComboToolBar::PreTranslateMessage(MSG* pMsg) 
{
	if(pMsg->message == WM_KEYDOWN) {
		switch (pMsg->wParam) {
		case VK_RETURN:
			if(m_combo.GetDroppedState()) {
				m_combo.ShowDropDown(FALSE);
			} else if(m_btnOK.m_hWnd) {
				AfxGetMainWnd()->PostMessage(WM_COMMAND, ID_BROWSE_OK);
				return TRUE;
			}
			AfxGetMainWnd()->PostMessage(WM_COMMAND, ID_FILE_PATH);
			return TRUE;
		case VK_DOWN:
			if(!m_combo.GetDroppedState()) {
				m_combo.ShowDropDown();
				return TRUE;
			}
			break;
		case VK_ESCAPE:
			GetMainFrame()->GetActiveView()->SetFocus();
			return TRUE;
		case VK_TAB:
			CView* pView = (CView*)GetMainFrame()->m_wndSplitter.GetPane(0, (::GetKeyState(VK_SHIFT) < 0));
			pView->SetFocus();
			GetMainFrame()->SetActiveView(pView);
			return TRUE;
		}
	}
	return CToolBar::PreTranslateMessage(pMsg);
}

void CComboToolBar::OnSetFocus(CWnd* pOldWnd) 
{
	m_combo.SetFocus();
	m_combo.SetEditSel(0,-1);
}

void CComboToolBar::OnSelectEndOk() 
{
	AfxGetMainWnd()->PostMessage(WM_COMMAND, ID_FILE_PATH);
}

/////////////////////////////////////////////////////////////////////////////
// CTBComboBox
/*

int CTBComboBox::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CComboBox::OnCreate(lpCreateStruct) == -1)
		return -1;

	LOGFONT logFont;
	memset(&logFont, 0, sizeof(logFont));

//	::GetObject(::GetStockObject(DEVICE_DEFAULT_FONT), sizeof(LOGFONT), &logFont);
//	logFont.lfWeight = FW_BOLD;
//	logFont.lfHeight = -9;

	logFont.lfHeight = -nComboHeight;
	logFont.lfWeight = FW_BOLD;
	logFont.lfCharSet = SHIFTJIS_CHARSET;
	logFont.lfQuality = DEFAULT_QUALITY;
	logFont.lfPitchAndFamily = VARIABLE_PITCH;

	if (m_font.CreateFontIndirect(&logFont))
		SetFont(&m_font);
	return 0;
}
*/