// ComboBox.cpp : implementation file
//

#include "stdafx.h"
#include "ComboBox.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CHistComboBox

CHistComboBox::CHistComboBox()
{
	m_pHistory = NULL;
	m_nHistMax = 10;
}

CHistComboBox::~CHistComboBox()
{
}


BEGIN_MESSAGE_MAP(CHistComboBox, CComboBox)
	//{{AFX_MSG_MAP(CHistComboBox)
	ON_CONTROL_REFLECT(CBN_DROPDOWN, OnDropDown)
	ON_CONTROL_REFLECT(CBN_KILLFOCUS, OnKillFocus)
	ON_WM_CREATE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHistComboBox message handlers

void CHistComboBox::OnDropDown() 
{
	// TODO: Add your control notification handler code here
	if(m_pHistory) {
		CString sText;
		GetWindowText(sText);
		if(IsLiteral(sText)) {
			if(FindText(sText))
				m_pHistory->InsertAt(0, sText);
		}
		ResetContent();
		SetWindowText(sText);
		for_to(i, m_pHistory->GetSize()) {
			CString s = (*m_pHistory)[i];
			TRACE(_T("%d:%s\n"), i, s);
			AddString(s);
		}
//		SetWindowText(sText);
	}
}

void CHistComboBox::OnKillFocus() 
{
	// TODO: Add your control notification handler code here
	if(m_pHistory) {
		CString sText;
		GetWindowText(sText);
		if(!sText.IsEmpty() && IsLiteral(sText)) {
			FindText(sText);
			if(m_pHistory->GetSize() >= m_nHistMax)
				m_pHistory->SetSize(m_nHistMax - 1);
			m_pHistory->InsertAt(0, sText);
		}
	}
}

BOOL CHistComboBox::IsLiteral(CString sText) {
	for_to(i, sText.GetLength()) {
		if(sText.GetAt(i) < 0 || sText.GetAt(i) >= 'A') return TRUE;
	}
	return FALSE;
}

CString CHistComboBox::GetText()
{
	CString sText;
	GetWindowText(sText);
	return sText;
}

void CHistComboBox::SetText(CString sText)
{
	DWORD dwSel = GetEditSel();
	SetWindowText(sText);
	CWnd* pWnd = GetFocus();
	if(pWnd && pWnd->GetParent() == this)
		SetEditSel(0,-1);
}

BOOL CHistComboBox::FindText(CString sText)
{
	for_to(i, m_pHistory->GetSize()) {
		if(sText.CompareNoCase((*m_pHistory)[i]) == 0) {
			m_pHistory->RemoveAt(i);
			return TRUE;
		}
	}
	return FALSE;
}

int CHistComboBox::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CComboBox::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: Add your specialized creation code here
	if(m_font.m_hObject)
		SetFont(&m_font);
	return 0;
}
