/////////////////////////////////////////////////////////////////////////////
// FTP.h

#ifndef FTP_H
#define FTP_H

#ifndef NO_FTP

struct FTPInfo
{
	CString m_sServer;
	CString m_sUserID;
	CString m_sPassword;
	UINT	m_nPort;
};

enum DisConnMode { DISCONN_KEEP, DISCONN_QUERY, DISCONN_HANGUP };

class AFX_EXT_CLASS CFTP
{
public:
	CFTP::CFTP();
	CFTP::~CFTP();
	BOOL Connect(FTPInfo* pInfo = NULL, UINT uCbMsg = 0, BOOL bWait = TRUE, BOOL bIgnoreError = FALSE);	// ###1.23
	void Close();
	void QueryHangUp();
	BOOL IsConnect() { return m_hFTP != NULL; }
	BOOL ParseURL(CString sURL, CString& sServer, CString& sObject);
	CString GetRoot(CString sURL);
	CString GetServer(CString sURL);
	CString MakeURL(CString sObject);
	BOOL IsFTPPath(CString sPath);
	void Load();
	void Save();
	FTPInfo* FindServer(CString sServer);
	BOOL RemoveServer(CString sServer);
	int GetServerCount() { return m_arrFTP.GetSize(); }
public:
	HINTERNET m_hINET;
	HINTERNET m_hFTP;
	FTPInfo* m_pInfo;
	UINT m_uCbMsg;
	BOOL m_bIgnoreError;	// ###1.23
	DWORD m_dwError;
	static CArray<FTPInfo, FTPInfo&> m_arrFTP;
	static DisConnMode m_disconn;
	static CString m_sTextMask;
	static UINT m_transfer;
	static BOOL m_bPassv;
};

extern AFX_EXT_CLASS CFTP ftp;

#endif // NO_FTP

#define CONTEXTID 1
#define SERVER_MAX 20

#endif // FTP_H


