// FTPDlg.cpp : implementation file
//

#include "stdafx.h"
#include "FTP.h"
#include "FTPDlg.h"
#include "hlp\topics.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFTPHost property page

IMPLEMENT_DYNCREATE(CFTPHost, CPropertyPage)

CFTPHost::CFTPHost() : CPropertyPage(CFTPHost::IDD)
{
	//{{AFX_DATA_INIT(CFTPHost)
	m_nPort = INTERNET_DEFAULT_FTP_PORT;
	m_sUserID = _T("");
	m_sPassword = _T("");
	m_bPassv = ftp.m_bPassv;
	//}}AFX_DATA_INIT
	m_bInit = FALSE;
}

CFTPHost::~CFTPHost()
{
}

void CFTPHost::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFTPHost)
	DDX_Control(pDX, IDC_SERVER, m_cbServer);
	DDX_Text(pDX, IDE_PORT, m_nPort);
	DDX_Text(pDX, IDE_USERID, m_sUserID);
	DDX_Text(pDX, IDE_PASSWORD, m_sPassword);
	DDX_Check(pDX, IDB_PASSV, m_bPassv);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CFTPHost, CPropertyPage)
	//{{AFX_MSG_MAP(CFTPHost)
	ON_BN_CLICKED(IDB_NEW, OnNew)
	ON_CBN_SELENDOK(IDC_SERVER, OnSelEndOKServer)
	ON_BN_CLICKED(IDB_DELETE, OnDelete)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFTPHost message handlers

BOOL CFTPHost::OnSetActive() 
{
	// TODO: Add your specialized code here and/or call the base class
	if(!m_bInit) {
		m_bInit = TRUE;
		Init();
	}
	return CPropertyPage::OnSetActive();
}

void CFTPHost::Init() 
{
	m_pFTPInfo = NULL;
	for_to(i, ftp.GetServerCount()) {
		m_sHistServer.Add(ftp.m_arrFTP[i].m_sServer);
	}
	m_cbServer.AttachHistory(&m_sHistServer);
	if(!m_sServerNew.IsEmpty()) {
		m_cbServer.SetWindowText(m_sServerNew);
		if(m_pFTPInfo = ftp.FindServer(m_sServerNew))
			SetInfo();
	}
	GetDlgItem(IDB_DELETE)->EnableWindow(m_pFTPInfo != NULL);
}

void CFTPHost::GetInfo()
{
	CString sServer = m_cbServer.GetText();
	if(sServer.IsEmpty()) return;
	if(!m_pFTPInfo) {
		FTPInfo info;
		m_pFTPInfo = &ftp.m_arrFTP[ftp.m_arrFTP.Add(info)];
	}
	UpdateData(TRUE);
	m_pFTPInfo->m_sServer = sServer;
	m_pFTPInfo->m_nPort = m_nPort;
	m_pFTPInfo->m_sUserID = m_sUserID;
	m_pFTPInfo->m_sPassword = m_sPassword;
}

void CFTPHost::SetInfo()
{
	if(m_pFTPInfo) {
		m_cbServer.SetWindowText(m_pFTPInfo->m_sServer);
		m_nPort = m_pFTPInfo->m_nPort;
		m_sUserID = m_pFTPInfo->m_sUserID;
		m_sPassword = m_pFTPInfo->m_sPassword;
		UpdateData(FALSE);
	}
}

void CFTPHost::OnNew() 
{
	// TODO: Add your control notification handler code here
	GetInfo();
	FTPInfo info;
	info.m_nPort = INTERNET_DEFAULT_FTP_PORT;
	m_pFTPInfo = &info;
	SetInfo();
	m_pFTPInfo = NULL;
}

void CFTPHost::OnDelete() 
{
	// TODO: Add your control notification handler code here
	if(m_pFTPInfo) {
		ftp.RemoveServer(m_pFTPInfo->m_sServer);
		m_sHistServer.RemoveAll();
		m_cbServer.ResetContent();
		Init();
	}
}

void CFTPHost::OnOK() 
{
	// TODO: Add your specialized code here and/or call the base class
	GetInfo();
	ftp.m_bPassv = m_bPassv;
	CPropertyPage::OnOK();
}

void CFTPHost::OnSelEndOKServer() 
{
	// TODO: Add your control notification handler code here
	CString sServer;
	m_cbServer.GetLBText(m_cbServer.GetCurSel(), sServer);
	m_pFTPInfo = ftp.FindServer(sServer);
	SetInfo();
	GetDlgItem(IDB_DELETE)->EnableWindow(TRUE);
}

/////////////////////////////////////////////////////////////////////////////
// CFTPDial property page

IMPLEMENT_DYNCREATE(CFTPDial, CPropertyPage)

CFTPDial::CFTPDial() : CPropertyPage(CFTPDial::IDD)
{
	//{{AFX_DATA_INIT(CFTPDial)
	m_disconn = ftp.m_disconn;
	//}}AFX_DATA_INIT
}

CFTPDial::~CFTPDial()
{
}

void CFTPDial::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFTPDial)
	DDX_Radio(pDX, IDB_KEEP, m_disconn);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CFTPDial, CPropertyPage)
	//{{AFX_MSG_MAP(CFTPDial)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFTPDial message handlers

void CFTPDial::OnOK() 
{
	// TODO: Add your specialized code here and/or call the base class

	ftp.m_disconn = (DisConnMode)m_disconn;
	CPropertyPage::OnOK();
}

/////////////////////////////////////////////////////////////////////////////
// CFTPTrans property page

IMPLEMENT_DYNCREATE(CFTPTrans, CPropertyPage)

CFTPTrans::CFTPTrans() : CPropertyPage(CFTPTrans::IDD)
{
	//{{AFX_DATA_INIT(CFTPTrans)
	m_sTextMask = ftp.m_sTextMask;
	m_transfer = ftp.m_transfer;
	//}}AFX_DATA_INIT
}

CFTPTrans::~CFTPTrans()
{
}

void CFTPTrans::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFTPTrans)
	DDX_Text(pDX, IDE_TEXTMASK, m_sTextMask);
	DDX_Radio(pDX, IDB_AUTO, m_transfer);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CFTPTrans, CPropertyPage)
	//{{AFX_MSG_MAP(CFTPTrans)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFTPTrans message handlers

void CFTPTrans::OnOK() 
{
	// TODO: Add your specialized code here and/or call the base class
	ftp.m_sTextMask = m_sTextMask;
	ftp.m_transfer = m_transfer;
	CPropertyPage::OnOK();
}

/////////////////////////////////////////////////////////////////////////////
// CFTPDlg

IMPLEMENT_DYNAMIC(CFTPDlg, CPropertySheet)

CFTPDlg::CFTPDlg(UINT nIDCaption, CWnd* pParentWnd, UINT iSelectPage)
	:CPropertySheet(nIDCaption, pParentWnd, iSelectPage)
{
	AddPage(&m_pageHost);
	AddPage(&m_pageDial);
	AddPage(&m_pageTrans);
}

/*
CFTPDlg::CFTPDlg(LPCTSTR pszCaption, CWnd* pParentWnd, UINT iSelectPage)
	:CPropertySheet(pszCaption, pParentWnd, iSelectPage)
{
}
*/

CFTPDlg::~CFTPDlg()
{
}


BEGIN_MESSAGE_MAP(CFTPDlg, CPropertySheet)
	//{{AFX_MSG_MAP(CFTPDlg)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDHELP, OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFTPDlg message handlers

BOOL CFTPDlg::OnInitDialog() 
{
	BOOL bResult = CPropertySheet::OnInitDialog();
	
	// TODO: Add your specialized code here
	GetDlgItem(IDCANCEL)->SetWindowText(_T("Cancel"));	
	GetDlgItem(IDHELP)->SetWindowText(_T("Help"));	
	return bResult;
}

void CFTPDlg::OnHelp() 
{
	// TODO: Add your control notification handler code here
	AfxGetApp()->WinHelp(HID_FTP_SETTINGS);
}
