/////////////////////////////////////////////////////////////////////////////
// FTPFile.h

#ifndef FTPFILE_H
#define FTPFILE_H

#include "FindFile.h"

class AFX_EXT_CLASS CFTPFile
{
public:
	CFTPFile();
	~CFTPFile();
	void SetFTP(HANDLE hFTP) { m_hFTP = hFTP; }
	BOOL IsOpened() { return m_hFile != NULL; }
	BOOL IsFTP() { return m_hFTP != NULL; }
	BOOL Open(LPCTSTR pFile, UINT mode, UINT transfer = FTP_TRANSFER_TYPE_BINARY);
	void Close();
	DWORD Read(LPVOID pBuff, DWORD dwSize);
	DWORD Write(LPVOID pBuff, DWORD dwSize);
	BOOL DeleteFile(LPCTSTR pFile);
	BOOL CreateDirectory(LPCTSTR pDir);
	BOOL RemoveDirectory(LPCTSTR pDir);
	BOOL Rename(LPCTSTR pPathOld, LPCTSTR pPathNew);
	DWORD GetAttributes(LPCTSTR pFile);
	BOOL SetAttributes(LPCTSTR pFile, DWORD dwAttr);
	BOOL GetTimes(FileTimes* pTimes);
	BOOL SetTimes(FileTimes* pTimes);
	CFileName AddPath(CFileName sPath, LPCTSTR pDir);
	HANDLE m_hFTP;
private:
	HANDLE m_hFile;
};

class AFX_EXT_CLASS CFTPFindFiles : public CFindFiles
{
public:
	virtual HANDLE FindFirstFile(LPCTSTR pPath, HANDLE hFTP, WIN32_FIND_DATA* pFindData);
	virtual BOOL FindNextFile(HANDLE hFindFile, HANDLE hFTP, WIN32_FIND_DATA* pFindData);
	virtual void FindClose(HANDLE hFindFile, HANDLE hFTP);
};

#ifndef FO_MOVE //these need to be kept in sync with the ones in shlobj.h
#define FO_MOVE           0x0001
#define FO_COPY           0x0002
#define FO_DELETE         0x0003
#define FO_RENAME         0x0004
#endif // FO_MOVE

#define FO_COMPARE		  0x0005	// ###1.20
#define FO_DUMMY          0x0000

class AFX_EXT_CLASS CFTPFileOp
{
public:
	CFTPFileOp();
	CString m_sOpMode;	// must initialize
	CFTPFile m_fileSrc;
	CFTPFile m_fileDst;
	BOOL m_bDone;

protected:
	UINT m_errbits;
	int  m_nErrCode;
	BOOL m_bError;
	BOOL m_bIgnoreError;	// ###0.93
	CDWordArray m_dwSkipErrors;
	LPVOID m_pBuffer;
	LPVOID m_pBuffer2;		// ###1.20 <-- CZCFind
	DWORD m_dwBuffer;	// must initialize
	UINT m_transfer;
	CStringArray m_TextMasks;

public:
	DWORD m_dwBytesPerCluster;		// ###1.20
	DWORDLONG m_dwlTotalBytes;
	DWORDLONG m_dwlDoneBytes;
	DWORDLONG m_dwlDoneDiskBytes;
protected:
	int m_nTotalFiles;
	int m_nDoneFiles;
	DWORDLONG m_dwlSubTotalBytes;
	DWORDLONG m_dwlSubDoneBytes;
	int m_nSubTotlaFiles;
	int m_nSubDoneFiles;


	virtual ~CFTPFileOp();
	void InitFileOp();
	void InitSubCounter();
	BOOL InitTotalDiskBytes(CFileName sPath);	// ###1.20
	void SetTotalParameters();
	virtual void Cancel() { }
	virtual BOOL IsCanceled() { return FALSE; }
	BOOL FileOperate(UINT wFunc, LPCTSTR pSrcDir, LPCTSTR pDstDir = NULL, CFindData* pSrcData = NULL, CFindData* pDstData = NULL);
	virtual BOOL OperateDefault(UINT wFunc, LPCTSTR pSrcFile, LPCTSTR pDstFile, CFindData* pSrcData, CFindData* pDstData);
#ifndef NO_FTP
	void ParseTextMask();
	UINT GetFileType(CFileName sFile);
#endif
	CString GetNextTerm(LPCTSTR& pMask);
	BOOL CopyFile(LPCTSTR pSrcFile, LPCTSTR pDstFile, CFindData* pSrcData);
	BOOL CreateDirectory(LPCTSTR pDstPath, LPCTSTR pSrcPath = NULL);	// ###0.93
	int  CompareFile(LPCTSTR pSrcFile, LPCTSTR pDstFile); // ###1.20
	virtual BOOL AllocBuffer();
	virtual void AddLog(CString sText) { }
	virtual void DrawStatus(DWORDLONG dwDoneBytes = 0) { }
	int ErrorMessageBox(LPCTSTR pCaption);
	int ErrorMessageDlg(LPCTSTR pFile, UINT nMsg=0);
private:
	BOOL OpenWriteFile(LPCTSTR pSrcFile, LPCTSTR pDstFile);	// ###0.93
};

#endif //FTPFILE_H
