// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "ZBrowse.h"
#include "MainFrm.h"
#include "ZBTreeVw.h"
#include "ZBListVw.h"
#include "pidl.h"
#include "FTP.h"
#include "FTPDlg.h"
#include "zczb.h"
#include "SortDlg.h"
#include <afxpriv.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// #define COMBO_WIDTH  180
#define COMBO_HEIGHT 268	// width of edit control for combobox
#define OKBTN_INDEX	 17		// ###1.20
#define OKBTN_WIDTH  64

#define IDTIMER 1

#define FAVORITES_MAX 32

#if !defined (WM_APPCOMMAND)
  #define WM_APPCOMMAND                   0x0319

  #define APPCOMMAND_BROWSER_BACKWARD       1
  #define APPCOMMAND_BROWSER_FORWARD        2

  #define FAPPCOMMAND_MASK  0xF000
  #define GET_APPCOMMAND_LPARAM(lParam) ((short)(HIWORD(lParam) & ~FAPPCOMMAND_MASK))
#endif // WM_APPCOMMAND

/////////////////////////////////////////////////////////////////////////////
// CZBSplitter

IMPLEMENT_DYNCREATE(CZBSplitterWnd, CSplitterWnd)

BEGIN_MESSAGE_MAP(CZBSplitterWnd, CSplitterWnd)
	//{{AFX_MSG_MAP(CZBSplitterWnd)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

CZBSplitterWnd::CZBSplitterWnd()
{ 
}

CZBSplitterWnd::~CZBSplitterWnd()
{                 
}

void CZBSplitterWnd::StopTracking(BOOL bAccept)
{
	CSplitterWnd::StopTracking(bAccept);
	if(bAccept) {
		int cxCur, cxMin;
		GetColumnInfo(0, cxCur, cxMin);
		GetMainFrame()->m_wndToolBar.ResizeComboBox(0, IDC_PATHCOMBO, cxCur);
		options.m_cxSplit = cxCur;
	}
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_FOLDER_UP, OnFolderUp)
	ON_COMMAND(ID_VIEW_TREESIZE, OnViewTreeSize)
	ON_COMMAND(ID_FOLDER_NEW, OnFolderNew)
	ON_UPDATE_COMMAND_UI(ID_FOLDER_NEW, OnUpdateFolderNew)
	ON_COMMAND(ID_VIEW_REFRESH, OnViewRefresh)
	ON_COMMAND(ID_EDIT_SELECT_ALL, OnEditSelectAll)
	ON_COMMAND(ID_EDIT_INVERT, OnEditInvert)
	ON_WM_CLOSE()
#ifndef NO_FTP
	ON_COMMAND(ID_FTP_DISCONNECT, OnFTPDisconnect)
	ON_COMMAND(ID_FTP_SETTING, OnFTPSetting)
	ON_UPDATE_COMMAND_UI(ID_FTP_DISCONNECT, OnUpdateFTPDisconnect)
#endif
	ON_COMMAND(ID_VIEW_REALNAME, OnViewRealName)
	ON_UPDATE_COMMAND_UI(ID_VIEW_REALNAME, OnUpdateViewRealName)
	ON_WM_TIMER()
	ON_COMMAND(ID_FILE_ADDRESS, OnFileAddress)
	ON_COMMAND(ID_FILE_NEWDOC, OnFileNewdoc)
	ON_COMMAND(ID_EDIT_FILEMASK, OnEditFilemask)
	ON_UPDATE_COMMAND_UI(ID_EDIT_FILEMASK, OnUpdateEditFilemask)
	ON_WM_INITMENUPOPUP()
	ON_WM_DRAWITEM()
	ON_WM_MEASUREITEM()
	ON_WM_MENUSELECT()
	ON_WM_MOVING()
	ON_COMMAND(ID_FOLDER_PREV, OnFolderPrev)
	ON_COMMAND(ID_FOLDER_NEXT, OnFolderNext)
	ON_UPDATE_COMMAND_UI(ID_FOLDER_PREV, OnUpdateFolderPrev)
	ON_UPDATE_COMMAND_UI(ID_FOLDER_NEXT, OnUpdateFolderNext)
	ON_COMMAND(ID_EDIT_COPYPATH, OnEditCopyPathname)
	ON_COMMAND(ID_FAVORITES_ADD, OnFavoritesAdd)
	ON_COMMAND(ID_FAVORITES_ORGANIZE, OnFavoritesOrganize)
	ON_COMMAND(ID_VIEW_UNFOLD, OnViewUnfold)
	ON_UPDATE_COMMAND_UI(ID_VIEW_UNFOLD, OnUpdateViewUnfold)
	ON_COMMAND(ID_STOP, OnStop)
	ON_UPDATE_COMMAND_UI(ID_STOP, OnUpdateStop)
	ON_COMMAND(ID_EDIT_SELECT_DUP, OnEditSelectDuplicate)
	ON_UPDATE_COMMAND_UI(ID_EDIT_SELECT_DUP, OnUpdateEditSelectDuplicate)
	ON_COMMAND(ID_FILE_EXTRACT, OnFileExtract)
	ON_UPDATE_COMMAND_UI(ID_FILE_EXTRACT, OnUpdateFileExtract)
	ON_COMMAND(ID_FILE_COMPRESS, OnFileCompress)
	ON_UPDATE_COMMAND_UI(ID_FILE_COMPRESS, OnUpdateFileCompress)
	ON_COMMAND(ID_EDIT_COPYTITLE, OnEditCopyTitle)
	//}}AFX_MSG_MAP
	ON_COMMAND(ID_FILE_PATH, OnFilePath)
#ifndef NO_FTP
	ON_COMMAND_RANGE(ID_FTP_CONNECT, ID_FTP_CONNECT + SERVER_MAX, OnFTPConnect)
#endif
	ON_MESSAGE(WM_SETMESSAGESTRING, OnSetMessageString)
	ON_MESSAGE(WM_DISPLAYCHANGE, OnDisplayChange)
	ON_WM_NCLBUTTONDOWN()
	ON_MESSAGE(WM_APPCOMMAND, OnAppCommand)
	ON_COMMAND_RANGE(ID_FAVORITES_OPEN, ID_FAVORITES_OPEN + FAVORITES_MAX, OnFavoritesOpen)
	ON_COMMAND_RANGE(ID_VIEW_ICON, ID_VIEW_THUMBNAIL, OnViewStyle)
	ON_UPDATE_COMMAND_UI_RANGE(ID_VIEW_ICON, ID_VIEW_THUMBNAIL, OnUpdateViewStyle)

END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_INFO
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
	m_pContextMenu = NULL;
	m_iFolderNow = -1;
	m_bWalkFolder = FALSE;
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	CWnd* pWnd = FindWindow(NULL, _T("ZCopy"));

	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
#if _MFC_VER >= 0x0600	
	if (!(options.m_bFlatBar ? m_wndToolBar.CreateEx(this, TBSTYLE_FLAT | TBSTYLE_TRANSPARENT, WS_CHILD | WS_VISIBLE | CBRS_TOP)
		: m_wndToolBar.Create(this)) ||
#else
	if (!m_wndToolBar.Create(this) ||
#endif
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME)) 
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	m_wndToolBar.m_cyTopBorder = 2;
	m_wndToolBar.m_cyBottomBorder = 2;

	m_wndToolBar.m_combo.m_font.CreatePointFont(90, _T("lr oSVbN"));
	if (!m_wndToolBar.CreateComboBox(0, IDC_PATHCOMBO, options.m_cxSplit, COMBO_HEIGHT)) {
		TRACE0("Failed to create combobox in toolbar\n");
		return -1;      // fail to create
	}
	m_wndToolBar.m_combo.AttachHistory(&options.m_sHistPath, options.m_nHistMax);

	if(options.m_nBrowse) {
		if (!m_wndToolBar.CreatePushButton(OKBTN_INDEX, ID_BROWSE_OK, OKBTN_WIDTH)) {
			TRACE0("Failed to create push button in toolbar\n");
			return -1;      // fail to create
		}
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Remove this if you don't want tool tips or a resizeable toolbar
	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() | CBRS_TOOLTIPS | CBRS_FLYBY);

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_TOP);
	EnableDocking(CBRS_ALIGN_TOP);
	DockControlBar(&m_wndToolBar);

	ShowControlBar(&m_wndToolBar, (options.m_barState & BARSTATE_TOOL) != 0, FALSE);
	ShowControlBar(&m_wndStatusBar, (options.m_barState & BARSTATE_STATUS) != 0, FALSE);

	AddConnectMenu();
	AddFavoritesMenu();
	SetTimer(IDTIMER, 1000, NULL);
	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs
	if(options.m_rFrame.IsRectEmpty()) {
		cs.cx = 640;
		cs.cy = 480;
	} else {
		if(((CZBrowseApp*)AfxGetApp())->m_bFirstInstance) {	// ###1.23
			SnapFrame(options.m_rFrame);
			cs.x = options.m_rFrame.x1;
			cs.y = options.m_rFrame.y1;
		}
		cs.cx = options.m_rFrame.Width();
		cs.cy = options.m_rFrame.Height();
	}
	if(CFrameWnd::PreCreateWindow(cs)) {
		if(!options.m_nBrowse) {	// ###1.23
			WNDCLASSEX wc;
			wc.cbSize = sizeof(WNDCLASSEX);
			VERIFY(::GetClassInfoEx(AfxGetInstanceHandle(), cs.lpszClass, &wc));
			wc.lpszClassName = sZBrowseClassName;
			wc.hIcon  = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
			wc.hIconSm = (HICON)::LoadImage(AfxGetResourceHandle(), MAKEINTRESOURCE(IDR_MAINFRAME), IMAGE_ICON, 16, 16, 0);
			::RegisterClassEx(&wc);
			cs.lpszClass = sZBrowseClassName;
		}
		return TRUE;
	}
	return FALSE;
}

BOOL CMainFrame::OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext) 
{
	// TODO: Add your specialized code here and/or call the base class
	m_wndSplitter.CreateStatic(this, 1, 2);
	CSize cTree(options.m_cxSplit, 0);
	CSize cList(0, 0);
	m_wndSplitter.CreateView(0, 0, RUNTIME_CLASS(CZBTreeView), cTree, pContext);
	m_wndSplitter.CreateView(0, 1, RUNTIME_CLASS(CZBListView), cList, pContext);

	return TRUE; //CFrameWnd::OnCreateClient(lpcs, pContext);
}

void CMainFrame::OnClose() 
{
	// TODO: Add your message handler code here and/or call default
	KillTimer(IDTIMER);
	GetFrameState();
	CFrameWnd::OnClose();
}

void CMainFrame::GetFrameState()
{
	WINDOWPLACEMENT wndpl;
	GetWindowPlacement(&wndpl);
	options.m_rFrame = wndpl.rcNormalPosition;
	options.m_bMaximized = IsZoomed();
	options.m_barState = m_wndToolBar.IsWindowVisible() * BARSTATE_TOOL | m_wndStatusBar.IsWindowVisible() * BARSTATE_STATUS;
}

HACCEL CMainFrame::GetDefaultAccelerator()
{
	CWnd* pWnd = GetFocus();
	CRuntimeClass* pClass = pWnd->GetRuntimeClass();
	if(pClass != RUNTIME_CLASS(CZBTreeView) && pClass != RUNTIME_CLASS(CZBListView))
		return NULL;
	return CFrameWnd::GetDefaultAccelerator();
}	

/////////////////////////////////////////////////////////////////////////////
// CMainFrame Operations

BOOL CMainFrame::BrowseFrom(LPCTSTR pPath, BOOL bFocus)
{
#ifndef NO_FTP
	if(!ftp.IsFTPPath(pPath)) {
		if(::GetFileAttributes(pPath) == -1)
			return FALSE;	// ###1.23
	}
#endif
	TRACE(_T("*** BrowseFrom %s (%d)\n"), pPath, m_bWalkFolder);
	if(m_bWalkFolder)
		GetListView()->SetPrevSelect(pPath);

	CZBTreeView* pTree = GetTreeView();
	pTree->SelectFrom(pPath);
	if(bFocus)
		pTree->SetFocus();
	return TRUE;
}

void CMainFrame::SetCaption(LPCTSTR pText, BOOL bFile)
{
	if(pText) m_sCaptionPath = pText;
	CString sCaption;
	if(options.m_sCaption.IsEmpty())
		sCaption = AfxGetAppName();
	else
		sCaption = options.m_sCaption;
	sCaption += _T(" - ") + m_sCaptionPath;
	if(bFile && GetListView()->IsFileMaskMode()) 
		sCaption += _T(" (") + GetListView()->GetFileMask() + _T(")");
	SetWindowText(sCaption);
}

void CMainFrame::OnUpdateFrameTitle(BOOL bAddToTitle)
{
}

void CMainFrame::SetFolder(CString sPath)
{
	m_wndToolBar.m_combo.SetText(sPath);
	m_sFolder = sPath;
	AddFolderHistory(sPath);
	m_bWalkFolder = FALSE;
}

void CMainFrame::ReportMessage(CString s)
{
//	m_wndStatusBar.SetPaneText(0, s);
//	m_wndStatusBar.RedrawWindow(NULL, NULL, RDW_UPDATENOW);
	SetMessageText(s);
}

void CMainFrame::ReportMessage(UINT nID, LPCTSTR pText)
{
	CString sMsg;
	sMsg.Format(nID, pText);
	ReportMessage(sMsg);
}

void CMainFrame::AddConnectMenu()
{
#ifndef NO_FTP
	CMenu* pMenu = GetMenu()->GetSubMenu(4);
	pMenu->EnableMenuItem(0, MF_BYPOSITION | (ftp.GetServerCount() ? MF_ENABLED : MF_GRAYED));
	pMenu = pMenu->GetSubMenu(0);
	int nCount = pMenu->GetMenuItemCount();
	for_to(i, nCount)
		pMenu->DeleteMenu(0, MF_BYPOSITION);
	for_to_(i, ftp.GetServerCount())

#endif
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

void CMainFrame::OnFilePath()
{
	CFileName sPath = m_wndToolBar.m_combo.GetText();
	if(sPath.IsEmpty())
		sPath = options.m_sBrowseFolder;
	OnFilePath(sPath);
}

void CMainFrame::OnFilePath(CFileName sPath)
{
	CString sMask;
	DWORD dwAttr = ::GetFileAttributes(sPath); // ###050521
	if(dwAttr == -1 || !(dwAttr & FILE_ATTRIBUTE_DIRECTORY)) {
		UINT fBits = sPath.GetElementBits();
		if(fBits & FN_EXT) {
			sMask = sPath.GetName();
			sPath = sPath.GetDir();
			sPath.DeleteSlash();
		} else if(!(fBits & FN_ROOT)) {
			sMask = sPath;
			sPath.Empty();
		}
	}

	if(!sMask.IsEmpty())
		GetListView()->SetFileMask(sMask);
	if(!sPath.IsEmpty())
		BrowseFrom(sPath);
	if(!sMask.IsEmpty())
		GetListView()->FillItems(NULL);
}

void CMainFrame::OnFolderUp() 
{
	// TODO: Add your command handler code here
	GetTreeView()->FolderUp();
}

void CMainFrame::OnFolderNew() 
{
	// TODO: Add your command handler code here
	SetActiveView(GetListView());
	GetListView()->NewItem(TRUE);
}

void CMainFrame::OnFileNewdoc() 
{
	// TODO: Add your command handler code here
	SetActiveView(GetListView());
	GetListView()->NewItem(FALSE);
}

void CMainFrame::OnViewTreeSize() 
{
	// TODO: Add your command handler code here
	GetListView()->CalcTreeSize();	
}

void CMainFrame::OnUpdateFolderNew(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(GetListView()->IsFileList());
}

void CMainFrame::OnViewRefresh() 
{
	// TODO: Add your command handler code here
	GetTreeView()->Refresh();
}

void CMainFrame::OnEditSelectAll() 
{
	// TODO: Add your command handler code here
	SetActiveView(GetListView());
	GetListView()->SelectAll();
}

void CMainFrame::OnEditInvert() 
{
	// TODO: Add your command handler code here
	SetActiveView(GetListView());
	GetListView()->SelectAll(TRUE);
}

#ifndef NO_FTP

void CMainFrame::OnFTPConnect(UINT nID) 
{
	CString sURL = _T("ftp://") + ftp.m_arrFTP[nID - ID_FTP_CONNECT].m_sServer;
	BrowseFrom(sURL);
}

void CMainFrame::OnFTPDisconnect() 
{
	// TODO: Add your command handler code here
	ftp.Close();
	ftp2.Close();
	ftp.QueryHangUp();
}

void CMainFrame::OnUpdateFTPDisconnect(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(ftp.IsConnect() || ftp2.IsConnect());
}

void CMainFrame::OnFTPSetting() 
{
	// TODO: Add your command handler code here
	CFTPDlg dlgFTP;
	dlgFTP.m_psh.dwFlags |= PSH_NOAPPLYNOW;
	if(dlgFTP.DoModal() == IDOK) {
		AddConnectMenu();
		GetTreeView()->RefreshFTP();
		ftp.Save();
	}
}

#endif // NO_FTP

LRESULT CMainFrame::OnSetMessageString(WPARAM wParam, LPARAM lParam)
{
	LRESULT lResult = CFrameWnd::OnSetMessageString(wParam, lParam);
	if(wParam == AFX_IDS_IDLEMESSAGE)
		GetListView()->DisplayInfo();
	return lResult;
}

void CMainFrame::OnViewRealName() 
{
	// TODO: Add your command handler code here
	options.m_viewStyle ^= STYLE_REALNAME;
	GetListView()->FillItems(NULL);
}

void CMainFrame::OnUpdateViewRealName(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	GetListView()->OnUpdateViewRealName(pCmdUI);
}

void CMainFrame::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	GetListView()->IsChangeNotify();	
	CFrameWnd::OnTimer(nIDEvent);
}

void CMainFrame::OnFileAddress() 
{
	// TODO: Add your command handler code here
	m_wndToolBar.m_combo.SetFocus();
	m_wndToolBar.m_combo.ShowDropDown(TRUE);
}

void CMainFrame::OnViewStyle(UINT nID)
{
	GetListView()->SetListStyle(nID - ID_VIEW_ICON);
}

void CMainFrame::OnUpdateViewStyle(CCmdUI* pCmdUI)
{
	pCmdUI->SetRadio(pCmdUI->m_nID == ID_VIEW_ICON + (UINT)GetListView()->GetListStyle());
}

void CMainFrame::OnEditFilemask() 
{
	// TODO: Add your command handler code here
	GetListView()->OnEditFilemask();
}

void CMainFrame::OnUpdateEditFilemask(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(GetListView()->IsFileList());
	pCmdUI->SetCheck(GetListView()->IsFileMaskMode());
}

void CMainFrame::OnViewUnfold() 
{
	// TODO: Add your command handler code here
	GetListView()->OnViewUnfold();
}

void CMainFrame::OnUpdateViewUnfold(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(GetListView()->IsUnfold());
}

void CMainFrame::OnStop() 
{
	// TODO: Add your command handler code here
	GetListView()->StopOperation();
}

void CMainFrame::OnUpdateStop(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(GetListView()->IsTaskBusy());
}

void CMainFrame::OnUpdateCmdUI()
{
	m_wndToolBar.OnUpdateCmdUI(this, TRUE);
}

void CMainFrame::OnEditCopyPathname() // ###1.20
{
	// TODO: Add your command handler code here
	CString sPath = m_wndToolBar.m_combo.GetText();
	CopyTextToClipboard(sPath);
}


void CMainFrame::OnEditCopyTitle() 
{
	// TODO: Add your command handler code here
	CString sTitle = GetListView()->GetSelectedFileTitle();
	CopyTextToClipboard(sTitle);
}

void CMainFrame::CopyTextToClipboard(CString sPath)
{
	if(!sPath.IsEmpty()) {
		if(OpenClipboard()) {
			::EmptyClipboard();
			int size = (sPath.GetLength() + 1) * sizeof(TCHAR);
			HGLOBAL hMemTxt = ::GlobalAlloc(GMEM_MOVEABLE, size);
			LPBYTE pMemTxt  = (LPBYTE)::GlobalLock(hMemTxt);
			LPTSTR pPath = sPath.GetBuffer();
			memcpy(pMemTxt, pPath, size);
			sPath.ReleaseBuffer();
			::GlobalUnlock(hMemTxt);
			::SetClipboardData(CF_TEXT, hMemTxt);
			::CloseClipboard();
		}
	}	
}

/////////////////////////////////////////////////////////////////////////////
// ContextMenu handler ( http://codeguru.earthweb.com/mfc/comments/4654.shtml )

#define FIRST_ITEM_ID 1

void CMainFrame::PopupContextMenu(LPSHELLFOLDER pSF, UINT nIDL, LPCITEMIDLIST* apIDL, POINT pt) 
{
	LPCONTEXTMENU lpcm = NULL;
	m_pContextMenu = NULL;
	if(pSF->GetUIObjectOf(GetSafeHwnd(), nIDL, apIDL, IID_IContextMenu, NULL, (LPVOID*)&lpcm) == NOERROR) {
		if(SUCCEEDED(lpcm->QueryInterface(IID_IContextMenu2, (void **)&m_pContextMenu))) {
			CMenu menu;
			if(menu.CreatePopupMenu()) {
				if(SUCCEEDED(m_pContextMenu->QueryContextMenu(menu.m_hMenu, 0, FIRST_ITEM_ID, 0xFFFFFFFF, CMF_NORMAL))) {
					int nCmd = menu.TrackPopupMenu(TPM_LEFTALIGN | TPM_RETURNCMD | TPM_RIGHTBUTTON, pt.x, pt.y, this);
					if(nCmd) {
						CMINVOKECOMMANDINFO cmi;
						ZeroMem(cmi),
						cmi.cbSize = sizeof(CMINVOKECOMMANDINFO);
						cmi.hwnd   = GetSafeHwnd();
						cmi.lpVerb = MAKEINTRESOURCEA(nCmd - FIRST_ITEM_ID); // ###_UNICODE
						cmi.nShow  = SW_SHOWNORMAL;
						m_pContextMenu->InvokeCommand(&cmi);
					}
				}
			}
			m_pContextMenu->Release();
			m_pContextMenu = NULL;
		}
		lpcm->Release();
	}
}

void CMainFrame::OnInitMenuPopup(CMenu* pPopupMenu, UINT nIndex, BOOL bSysMenu) 
{
	// TODO: Add your message handler code here
	HMENU hMenu = pPopupMenu->GetSafeHmenu();

    if(m_pContextMenu && hMenu)
		m_pContextMenu->HandleMenuMsg(WM_INITMENUPOPUP, (WPARAM)hMenu, MAKELPARAM(nIndex, bSysMenu));
	else
		CFrameWnd::OnInitMenuPopup(pPopupMenu, nIndex, bSysMenu);
}

void CMainFrame::OnDrawItem(int nIDCtl, LPDRAWITEMSTRUCT lpDrawItemStruct)
{
	if(m_pContextMenu)
		m_pContextMenu->HandleMenuMsg(WM_DRAWITEM, (WPARAM)nIDCtl, (LPARAM)lpDrawItemStruct);
	else
		CFrameWnd::OnDrawItem(nIDCtl, lpDrawItemStruct);
}

void CMainFrame::OnMeasureItem(int nIDCtl, LPMEASUREITEMSTRUCT lpMeasureItemStruct)
{
	if(m_pContextMenu)
		m_pContextMenu->HandleMenuMsg(WM_MEASUREITEM, (WPARAM)nIDCtl, (LPARAM)lpMeasureItemStruct);
	else
		CFrameWnd::OnMeasureItem(nIDCtl, lpMeasureItemStruct);
}

void CMainFrame::OnMenuSelect( UINT nItemID, UINT nFlags,  HMENU hSysMenu )
{
	if(m_pContextMenu) {
		char szBuf[256];
		if(nItemID >= FIRST_ITEM_ID 
			&& SUCCEEDED(m_pContextMenu->GetCommandString(nItemID - FIRST_ITEM_ID, GCS_HELPTEXT, NULL, szBuf, sizeof(szBuf))))
			SetMessageText(CA2W(szBuf)); // ###_UNICODE
	} else
		CFrameWnd::OnMenuSelect(nItemID, nFlags, hSysMenu);
}

/////////////////////////////////////////////////////////////////////////////
// Snap window to desktop edge

#define SNAP_LEFT	1
#define SNAP_RIGHT	2
#define SNAP_TOP	4
#define SNAP_BOTTOM	8

void CMainFrame::OnMoving(UINT fwSide, LPRECT pRect) 
{
	CFrameWnd::OnMoving(fwSide, pRect);
	
	// TODO: Add your message handler code here
	if(options.m_nSnap == 0) return;
//	TRACE(_T("OnMoving %X %d,%d\n"), fwSide, pRect->x1, pRect->y1);
//	if(pRect->x1 > 0 && pRect->x1 < m_rFrame.x1 && pRect->x1 <= options.m_nSnap)
//		pRect->x1 = 0;

	CRect rScrn;
	::SystemParametersInfo(SPI_GETWORKAREA, 1, &rScrn, 0);
//	int cxScreen = ::GetSystemMetrics(SM_CXSCREEN);
//	int cyScreen = ::GetSystemMetrics(SM_CYSCREEN);
	UINT snapflag = 0;
	if(pRect->x1 <= rScrn.x1 + options.m_nSnap && pRect->x1 >= rScrn.x1 - options.m_nSnap)
		snapflag |= SNAP_LEFT;
	if(pRect->x2 >= rScrn.x2 - options.m_nSnap && pRect->x2 <= rScrn.x2 + options.m_nSnap)
		snapflag |= SNAP_RIGHT;
	if(pRect->y1 <= rScrn.y1 + options.m_nSnap && pRect->y1 >= rScrn.y1 - options.m_nSnap)
		snapflag |= SNAP_TOP;
	if(pRect->y2 >= rScrn.y2 - options.m_nSnap && pRect->y2 <= rScrn.y2 + options.m_nSnap)
		snapflag |= SNAP_BOTTOM;
	if(snapflag == 0) return;

	CPoint ptFrame(pRect->x1, pRect->y1);
	CSize  cFrame(CRect(pRect).Size());
	POINT ptCsr;
	::GetCursorPos(&ptCsr);
	if((options.m_snapflag ^ snapflag) & snapflag) {
		m_ptSnapCsr = ptCsr;
		TRACE(_T("m_ptSnapCsr = %d,%d\n"), m_ptSnapCsr.x, m_ptSnapCsr.y);
	} else {
		if(snapflag & (SNAP_LEFT | SNAP_RIGHT) && labs(m_ptSnapCsr.x - ptCsr.x) > options.m_nSnap) {
			snapflag &= ~(SNAP_LEFT | SNAP_RIGHT);
			ptFrame.x -= m_ptSnapCsr.x - ptCsr.x;
			TRACE(_T("X Released!\n"));
		}
		if(snapflag & (SNAP_TOP | SNAP_BOTTOM) && labs(m_ptSnapCsr.y - ptCsr.y) > options.m_nSnap) {
			snapflag &= ~(SNAP_TOP | SNAP_BOTTOM);
			ptFrame.y -= m_ptSnapCsr.y - ptCsr.y;
			TRACE(_T("Y Released!\n"));
		}
	}
	if(snapflag & SNAP_LEFT)
		ptFrame.x = rScrn.x1;
	else if(snapflag & SNAP_RIGHT)
		ptFrame.x = rScrn.x2 - cFrame.cx;
	if(snapflag & SNAP_TOP)
		ptFrame.y = rScrn.y1;
	else if(snapflag & SNAP_BOTTOM)
		ptFrame.y = rScrn.y2 - cFrame.cy;

	options.m_snapflag = snapflag;
	*pRect = CRect(ptFrame, cFrame);
}

void CMainFrame::OnNcLButtonDown(UINT nHitTest, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
//	TRACE(_T("OnNcLButtonDown %X %d,%d\n"), nHitTest, point.x, point.y);
	::GetCursorPos(&m_ptSnapCsr);
	CFrameWnd::OnNcLButtonDown(nHitTest, point);
}

LRESULT CMainFrame::OnDisplayChange(WPARAM wParam, LPARAM lParam)
{
	CRect rFrame;
	GetWindowRect(rFrame);
	if(SnapFrame(rFrame)) {
		TRACE(_T("Move to %d,%d\n"), rFrame.x1, rFrame.y1);
		MoveWindow(rFrame);
	}
	return 1;
}

BOOL CMainFrame::SnapFrame(LPRECT pRect)
{
	if(!options.m_snapflag) return FALSE;

	CRect rScrn;
	::SystemParametersInfo(SPI_GETWORKAREA, 1, &rScrn, 0);
	CPoint ptFrame(pRect->x1, pRect->y1);
	CSize  cFrame(CRect(pRect).Size());

	if(options.m_snapflag & SNAP_LEFT)
		ptFrame.x = rScrn.x1;
	else if(options.m_snapflag & SNAP_RIGHT) {
		ptFrame.x = rScrn.x2 - cFrame.cx;
		if(ptFrame.x < 0) {		// ###1.20
			ptFrame.x = 0;
			cFrame.cx = rScrn.Width();
		}
	}
	if(options.m_snapflag & SNAP_TOP)
		ptFrame.y = rScrn.y1;
	else if(options.m_snapflag & SNAP_BOTTOM) {
		ptFrame.y = rScrn.y2 - cFrame.cy;
		if(ptFrame.y < 0) {
			ptFrame.y = 0;
			cFrame.cy = rScrn.Height();
		}
	}
	*pRect = CRect(ptFrame, cFrame);
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// Walk on Folders  ###1.20

void CMainFrame::AddFolderHistory(CString sPath)
{
	if(!m_bWalkFolder && !sPath.IsEmpty()) {
		if(m_iFolderNow >= 0 && m_iFolderNow < m_sarrFolders.GetSize()) {
			if(sPath.CompareNoCase(m_sarrFolders[m_iFolderNow]) == 0) return;
		}
		m_sarrFolders.SetSize(++m_iFolderNow);
		m_sarrFolders.Add(sPath);
	}
	m_bWalkFolder = FALSE;
}

void CMainFrame::OnFolderPrev() 
{
	// TODO: Add your command handler code here
	m_bWalkFolder = TRUE;
	while(!BrowseFrom(m_sarrFolders[--m_iFolderNow])) {	// ###1.23
		m_sarrFolders.RemoveAt(m_iFolderNow);
		if(m_iFolderNow == 0) {
			m_bWalkFolder = FALSE;
			break;
		}
	}
}

void CMainFrame::OnFolderNext() 
{
	// TODO: Add your command handler code here
	m_bWalkFolder = TRUE;
	while(!BrowseFrom(m_sarrFolders[++m_iFolderNow])) {
		m_sarrFolders.RemoveAt(m_iFolderNow);
		if(m_iFolderNow >= m_sarrFolders.GetSize() - 1) {
			m_bWalkFolder = FALSE;
			break;
		}
	}
}

void CMainFrame::OnUpdateFolderPrev(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(m_iFolderNow > 0);
}

void CMainFrame::OnUpdateFolderNext(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(m_iFolderNow < m_sarrFolders.GetSize() - 1);
}

// Hook default TreeCtrl navigation

LRESULT CMainFrame::OnAppCommand(WPARAM wParam, LPARAM lParam)
{
	int cmd  = GET_APPCOMMAND_LPARAM(lParam);
	if(cmd == APPCOMMAND_BROWSER_BACKWARD) {
			PostMessage(WM_COMMAND, ID_FOLDER_PREV);
			return TRUE;
	}
	if(cmd == APPCOMMAND_BROWSER_FORWARD) {
			PostMessage(WM_COMMAND, ID_FOLDER_NEXT);
			return TRUE;
	}
	return CFrameWnd::DefWindowProc(WM_APPCOMMAND, wParam, lParam);
}

void CMainFrame::OnEditSelectDuplicate() 
{
	// TODO: Add your command handler code here
	GetListView()->SelectDuplicateFiles();
}

void CMainFrame::OnUpdateEditSelectDuplicate(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(GetListView()->IsFileList());
}

/////////////////////////////////////////////////////////////////////////////
// Favorites manager ###1.20

void CMainFrame::OnFavoritesAdd() 
{
	// TODO: Add your command handler code here
	CString sPath = m_wndToolBar.m_combo.GetText();
	if(!sPath.IsEmpty()) {
		for_to(i, options.m_sFavorPath.GetSize()) {
			if(sPath.CompareNoCase(options.m_sFavorPath[i]) == 0) {
				options.m_sFavorPath.RemoveAt(i);
				break;
			}
		}
		options.m_sFavorPath.Add(sPath);
		AddFavoritesMenu();
	}
}

void CMainFrame::OnFavoritesOrganize() 
{
	// TODO: Add your command handler code here
	CSortDialog dlg(&options.m_sFavorPath);
	if(dlg.DoModal() == IDOK)
		AddFavoritesMenu();
}

void CMainFrame::OnFavoritesOpen(UINT nID)
{
	OnFilePath(options.m_sFavorPath[nID - ID_FAVORITES_OPEN]);
}

void CMainFrame::AddFavoritesMenu()
{
	CMenu* pMenu = GetMenu()->GetSubMenu(3);
	int nCount = pMenu->GetMenuItemCount() - 3;
	for_to(i, nCount)
		pMenu->DeleteMenu(3, MF_BYPOSITION);
	for_to_(i, options.m_sFavorPath.GetSize()) {
		CString sLabel = _T("  ");
		if(i < 9) sLabel.Format(_T("&%d "), i + 1);
		else if(i == 9) sLabel = _T("&0 ");
		sLabel += options.m_sFavorPath[i];
		pMenu->AppendMenu(MF_BYPOSITION|MF_STRING, ID_FAVORITES_OPEN + i, sLabel);
	}
}

void CMainFrame::OnFileExtract() 
{
	// TODO: Add your command handler code here
	GetListView()->Extract();
}

void CMainFrame::OnFileCompress() 
{
	// TODO: Add your command handler code here
	
}

void CMainFrame::OnUpdateFileExtract(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(GetListView()->IsListExtract());
}

void CMainFrame::OnUpdateFileCompress(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(GetTreeView()->IsTreeComress());
}
