// MainFrm.h : interface of the CMainFrame class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MAINFRM_H__B884EA8E_9BC3_11D2_AE74_00400533897F__INCLUDED_)
#define AFX_MAINFRM_H__B884EA8E_9BC3_11D2_AE74_00400533897F__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "ComboBar.h"
#include "pidl.h"
#include "filename.h"

/////////////////////////////////////////////////////////////////////////////
// CZBSplitter

class CZBSplitterWnd : public CSplitterWnd
{
public: // create from serialization only
   	CZBSplitterWnd();
	DECLARE_DYNCREATE(CZBSplitterWnd)

// Implementation
public:
	virtual ~CZBSplitterWnd();
	virtual void StopTracking(BOOL bAccept);

	// Generated message map functions
	//{{AFX_MSG(CSplitter)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

class CZBTreeView;
class CZBListView;

class CMainFrame : public CFrameWnd
{
protected: // create from serialization only
	CMainFrame();
	DECLARE_DYNCREATE(CMainFrame)

// Attributes
private:
	CString m_sCaptionPath;
	IContextMenu2 * m_pContextMenu;
	CPoint m_ptSnapCsr;
public:
	CZBSplitterWnd m_wndSplitter;
	CString m_sFolder;

	// ###1.20
	CStringArray m_sarrFolders;
	int m_iFolderNow;
	BOOL m_bWalkFolder;

// Operations
public:
	BOOL BrowseFrom(LPCTSTR pPath, BOOL bFocus = FALSE);
	CZBTreeView* GetTreeView() { return (CZBTreeView*)m_wndSplitter.GetPane(0, 0); }
	CZBListView* GetListView() { return (CZBListView*)m_wndSplitter.GetPane(0, 1); }
	void SetCaption(LPCTSTR pText = NULL, BOOL bFile = TRUE);
	void SetFolder(CString sPath);
	void ReportMessage(CString s);
	void ReportMessage(UINT nID, LPCTSTR pText);
	void SetStatusBarText(int i, LPCTSTR pText) { m_wndStatusBar.SetPaneText(i, pText); }
	void PopupContextMenu(LPSHELLFOLDER pSF, UINT nIDL, LPCITEMIDLIST* apIDL, POINT pt);
	void GetFrameState();

	// ###1.20
	void AddFolderHistory(CString sPath);
	void OnUpdateCmdUI();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMainFrame)
	public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual BOOL OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext);
	//}}AFX_VIRTUAL
	virtual HACCEL GetDefaultAccelerator();
	virtual void OnUpdateFrameTitle(BOOL bAddToTitle);

// Implementation
private:
	void AddConnectMenu();
	void AddFavoritesMenu();
	BOOL SnapFrame(LPRECT pRect);
	void OnFilePath(CFileName sPath);
	void CopyTextToClipboard(CString sPath);

public:
	virtual ~CMainFrame();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

public:  // control bar embedded members
	CStatusBar  m_wndStatusBar;
	CComboToolBar m_wndToolBar;

// Generated message map functions
protected:
	//{{AFX_MSG(CMainFrame)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnFolderUp();
	afx_msg void OnViewTreeSize();
	afx_msg void OnFolderNew();
	afx_msg void OnUpdateFolderNew(CCmdUI* pCmdUI);
	afx_msg void OnViewRefresh();
	afx_msg void OnEditSelectAll();
	afx_msg void OnEditInvert();
	afx_msg void OnClose();
	afx_msg void OnFTPDisconnect();
	afx_msg void OnFTPSetting();
	afx_msg void OnUpdateFTPDisconnect(CCmdUI* pCmdUI);
	afx_msg void OnViewRealName();
	afx_msg void OnUpdateViewRealName(CCmdUI* pCmdUI);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnFileAddress();
	afx_msg void OnFileNewdoc();
	afx_msg void OnEditFilemask();
	afx_msg void OnUpdateEditFilemask(CCmdUI* pCmdUI);
	afx_msg void OnInitMenuPopup(CMenu* pPopupMenu, UINT nIndex, BOOL bSysMenu);
	afx_msg void OnDrawItem(int nIDCtl, LPDRAWITEMSTRUCT lpDrawItemStruct);
	afx_msg void OnMeasureItem(int nIDCtl, LPMEASUREITEMSTRUCT lpMeasureItemStruct);
	afx_msg void OnMenuSelect(UINT nItemID, UINT nFlags, HMENU hSysMenu);
	afx_msg void OnMoving(UINT fwSide, LPRECT pRect);
	afx_msg void OnFolderPrev();
	afx_msg void OnFolderNext();
	afx_msg void OnUpdateFolderPrev(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFolderNext(CCmdUI* pCmdUI);
	afx_msg void OnEditCopyPathname();
	afx_msg void OnFavoritesAdd();
	afx_msg void OnFavoritesOrganize();
	afx_msg void OnViewUnfold();
	afx_msg void OnUpdateViewUnfold(CCmdUI* pCmdUI);
	afx_msg void OnStop();
	afx_msg void OnUpdateStop(CCmdUI* pCmdUI);
	afx_msg void OnEditSelectDuplicate();
	afx_msg void OnUpdateEditSelectDuplicate(CCmdUI* pCmdUI);
	afx_msg void OnFileExtract();
	afx_msg void OnUpdateFileExtract(CCmdUI* pCmdUI);
	afx_msg void OnFileCompress();
	afx_msg void OnUpdateFileCompress(CCmdUI* pCmdUI);
	afx_msg void OnEditCopyTitle();
	//}}AFX_MSG
	afx_msg void OnFilePath();
#ifndef NO_FTP
	afx_msg void OnFTPConnect(UINT nID);
#endif
	afx_msg LRESULT OnSetMessageString(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnDisplayChange(WPARAM wParam, LPARAM lParam);
	afx_msg void OnNcLButtonDown(UINT nHitTest, CPoint point);
	afx_msg LRESULT OnAppCommand(WPARAM wParam, LPARAM lParam);
	afx_msg void OnFavoritesOpen(UINT nID);
	afx_msg void OnViewStyle(UINT nID);
	afx_msg void OnUpdateViewStyle(CCmdUI* pCmdUI);
	DECLARE_MESSAGE_MAP()
};

inline CMainFrame* GetMainFrame() { return (CMainFrame*)AfxGetMainWnd(); }

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MAINFRM_H__B884EA8E_9BC3_11D2_AE74_00400533897F__INCLUDED_)
