/////////////////////////////////////////////////////////////////////////////
// RASCtrl.cpp

#include "stdafx.h"
#include <ras.h>
#include <rasdlg.h>
#include <raserror.h>
#include "RASCtrl.h"

typedef DWORD (WINAPI*LPFN_RASENUMCONNECTIONS) (LPRASCONN , LPDWORD , LPDWORD);
typedef DWORD (WINAPI*LPFN_RASHANGUP) (HRASCONN);
typedef DWORD (WINAPI*LPFN_RASENUMENTRIES) (LPTSTR, LPTSTR, LPRASENTRYNAME, LPDWORD, LPDWORD);

static HINSTANCE  hDllRasAPI32 = NULL;
static LPFN_RASENUMCONNECTIONS lpfnRasEnumConnections = NULL;
static LPFN_RASHANGUP lpfnRasHangUp = NULL;
static LPFN_RASENUMENTRIES lpfnRasEnumEntries = NULL;

BOOL LoadRasAPI()
{
	static BOOL bNoDll = FALSE;
	if(bNoDll)
		return FALSE;
	if(!hDllRasAPI32) {
		hDllRasAPI32 = LoadLibrary(_T("rasapi32.dll"));
		if(hDllRasAPI32) {
			lpfnRasEnumConnections = (LPFN_RASENUMCONNECTIONS)GetProcAddress(hDllRasAPI32, "RasEnumConnectionsA"); // ###_UNICODE
			lpfnRasHangUp = (LPFN_RASHANGUP)GetProcAddress(hDllRasAPI32, "RasHangUpA");
			lpfnRasEnumEntries = (LPFN_RASENUMENTRIES)GetProcAddress(hDllRasAPI32, "RasEnumEntriesA");
		} else {
			bNoDll = TRUE;
			return FALSE;
		}
	}
	return TRUE;
}

static HRASCONN GetRasConnection()
{
	if(!LoadRasAPI()) return NULL;
	HRASCONN hRasConn = NULL;
	LPRASCONN lpRasConn = new RASCONN;
	DWORD dwBuf = sizeof(RASCONN);
    DWORD nConn = 0;

	lpRasConn->dwSize = sizeof(RASCONN);                      
	DWORD dwResult = (*lpfnRasEnumConnections)(lpRasConn, &dwBuf, &nConn);
	if(!dwResult && nConn)
		hRasConn = lpRasConn->hrasconn;
	delete lpRasConn;
	return hRasConn;
}

void HangUp() 
{
	if(!LoadRasAPI()) return;
	HRASCONN hRasConn = GetRasConnection();
	if(hRasConn)
		(*lpfnRasHangUp)(hRasConn);
}

BOOL IsRasConnected(BOOL bLoadDll)
{
	if(!bLoadDll && !hDllRasAPI32) return NULL;
	return GetRasConnection() != NULL;
}

void SetPBEntries(CComboBox& combo, CString& sCurEntry)
{
	if(!LoadRasAPI()) return;
	DWORD dwBuf = sizeof(RASENTRYNAME);
	DWORD nEntry;
	LPRASENTRYNAME lpRasEntry = new RASENTRYNAME[1];
	lpRasEntry->dwSize = sizeof(RASENTRYNAME);
	DWORD dwRet = (*lpfnRasEnumEntries)(NULL, NULL, lpRasEntry, &dwBuf, &nEntry);
	if(dwRet == ERROR_BUFFER_TOO_SMALL) {
		delete lpRasEntry;
		lpRasEntry = new RASENTRYNAME[nEntry];
		lpRasEntry->dwSize = sizeof(RASENTRYNAME);
		dwRet = (*lpfnRasEnumEntries)(NULL, NULL, lpRasEntry, &dwBuf, &nEntry);
	}
	if(!dwRet) {
		combo.ResetContent();
		for_to(i, (int)nEntry) {
			combo.AddString(lpRasEntry[i].szEntryName);
		}
		if(!sCurEntry.IsEmpty()) {
			int iSel = combo.FindStringExact(0, sCurEntry);
			if(iSel != CB_ERR) {
				combo.SetCurSel(iSel);
			}
		}
	}
	delete lpRasEntry;
}


