// RichEdit.cpp : implementation file
//

#include "stdafx.h"
#include "RichCtrl.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// _AFX_RICHEDIT_STATE_X class

_AFX_RICHEDIT_STATE_X _afxRichEditStateX;

_AFX_RICHEDIT_STATE_X::_AFX_RICHEDIT_STATE_X()
{
	m_hInstRichEdit = NULL;
}

_AFX_RICHEDIT_STATE_X::~_AFX_RICHEDIT_STATE_X()
{
	if(m_hInstRichEdit)
		::FreeLibrary(m_hInstRichEdit);
}

BOOL AFXAPI _AfxInitRichEdit2()
{
	if(!AfxInitRichEdit())
		return FALSE;

	if(_afxRichEditStateX.m_hInstRichEdit == NULL) {
		if((_afxRichEditStateX.m_hInstRichEdit = ::LoadLibrary(_T("RICHED20.DLL"))) == NULL)
			return FALSE;
	}
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CxRichEditCtrl

CxRichEditCtrl::CxRichEditCtrl()
{
}

CxRichEditCtrl::~CxRichEditCtrl()
{
}


BEGIN_MESSAGE_MAP(CxRichEditCtrl, CRichEditCtrl)
	//{{AFX_MSG_MAP(CxRichEditCtrl)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BOOL CxRichEditCtrl::Create(DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID)
{
	if(!_AfxInitRichEdit2())
		return FALSE;

	CWnd* pWnd = this;
	return pWnd->Create(_T("RICHEDIT20A"), NULL, dwStyle, rect, pParentWnd, nID);
}

DWORD CxRichEditCtrl::GetDefaultCharFormat2(CHARFORMAT2 &cf)
{
	ASSERT(::IsWindow(m_hWnd));
	cf.cbSize = sizeof(CHARFORMAT2);
	return (DWORD)SendMessage(EM_GETCHARFORMAT, 0, (LPARAM)&cf);
}

DWORD CxRichEditCtrl::GetSelectionCharFormat2(CHARFORMAT2 &cf)
{
	ASSERT(::IsWindow(m_hWnd));
	cf.cbSize = sizeof(CHARFORMAT2);
	return (DWORD)SendMessage(EM_GETCHARFORMAT, 1, (LPARAM)&cf);
}

BOOL CxRichEditCtrl::SetDefaultCharFormat2(CHARFORMAT2 &cf)
{
	ASSERT(::IsWindow(m_hWnd));
	cf.cbSize = sizeof(CHARFORMAT2);
	return (BOOL)SendMessage(EM_SETCHARFORMAT, 0, (LPARAM)&cf);
}

BOOL CxRichEditCtrl::SetSelectionCharFormat2(CHARFORMAT2 &cf)
{
	ASSERT(::IsWindow(m_hWnd));
	cf.cbSize = sizeof(CHARFORMAT2);
	return (BOOL)SendMessage(EM_SETCHARFORMAT, SCF_SELECTION, (LPARAM)&cf);
}

DWORD CxRichEditCtrl::GetParaFormat2(PARAFORMAT2 &pf)
{
	ASSERT(::IsWindow(m_hWnd));
	pf.cbSize = sizeof(PARAFORMAT2);
	return (DWORD)SendMessage(EM_GETPARAFORMAT, 0, (LPARAM)&pf);
}

BOOL CxRichEditCtrl::SetParaFormat2(PARAFORMAT2 &pf)
{
	ASSERT(::IsWindow(m_hWnd));
	pf.cbSize = sizeof(PARAFORMAT2);
	return (BOOL)SendMessage(EM_SETPARAFORMAT, 0, (LPARAM)&pf);
}

void CxRichEditCtrl::SetTextMode()
{
	ASSERT(::IsWindow(m_hWnd));
	SendMessage(EM_SETTEXTMODE, TM_PLAINTEXT);
}

DWORD CxRichEditCtrl::GetLangOptions()
{
	ASSERT(::IsWindow(m_hWnd));
	return (DWORD)SendMessage(EM_GETLANGOPTIONS);
}

void CxRichEditCtrl::SetLangOptions(DWORD dwOptions)
{
	ASSERT(::IsWindow(m_hWnd));
	SendMessage(EM_SETLANGOPTIONS, 0, dwOptions);
}

void CxRichEditCtrl::SetLineSpacing()
{
	CHARFORMAT cf;
	GetDefaultCharFormat(cf);

	PARAFORMAT2 pf;
	pf.dwMask = PFM_LINESPACING | PFM_SPACEBEFORE;
	pf.dyLineSpacing = cf.yHeight;
	pf.bLineSpacingRule = 4;
	pf.dySpaceBefore = cf.yHeight / 5;
	SetParaFormat2(pf);
}


/////////////////////////////////////////////////////////////////////////////
// CxRichEditCtrl message handlers
