// SortDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ZBrowse.h"
#include "SortDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSortDialog dialog


CSortDialog::CSortDialog(CStringArray* psarrList, CWnd* pParent /*=NULL*/)
	: CDialog(CSortDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSortDialog)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_psarrList = psarrList;
}


void CSortDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSortDialog)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSortDialog, CDialog)
	//{{AFX_MSG_MAP(CSortDialog)
	ON_COMMAND(ID_LIST_DELETE, OnListDelete)
	ON_COMMAND(ID_LIST_UP, OnListUp)
	ON_COMMAND(ID_LIST_DOWN, OnListDown)
	//}}AFX_MSG_MAP
	ON_NOTIFY_EX_RANGE(TTN_NEEDTEXT, 0, 0xFFFF, OnToolTipNotify)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSortDialog message handlers

CListBox& CSortDialog::GetListBox()
{
	CWnd* pWnd = GetDlgItem(IDC_ITEMLIST);
	ASSERT(pWnd);
	return (CListBox&)*pWnd;
}

BOOL CSortDialog::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here

	m_toolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP);
	m_toolBar.LoadToolBar(IDR_ORGANIZE);
	m_toolBar.SetBarStyle(CBRS_ALIGN_TOP | CBRS_TOOLTIPS | CBRS_FLYBY);
	RepositionBars(AFX_IDW_CONTROLBAR_FIRST, AFX_IDW_CONTROLBAR_LAST, 0);

	CRect rToolBar, rButton, rListBox;
	m_toolBar.GetItemRect(2, rButton);
	m_toolBar.GetWindowRect(rToolBar);
	ScreenToClient(rToolBar);
	GetListBox().GetWindowRect(rListBox);
	ScreenToClient(rListBox);
	m_toolBar.MoveWindow(rListBox.right - rButton.right, rListBox.top - rToolBar.Height() - 2, rToolBar.Width(), rToolBar.Height());

	for_to(i, m_psarrList->GetSize())
		GetListBox().AddString(m_psarrList->ElementAt(i));

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

BOOL CSortDialog::OnToolTipNotify(UINT id, NMHDR * pNMHDR, LRESULT * pResult)
{
    TOOLTIPTEXT *pTTT = (TOOLTIPTEXT *)pNMHDR;
    UINT nID =pNMHDR->idFrom;
	pTTT->lpszText = MAKEINTRESOURCE(nID);
	pTTT->hinst = AfxGetResourceHandle();
	return(TRUE);
}

void CSortDialog::OnListDelete() 
{
	// TODO: Add your command handler code here
	CListBox& list = GetListBox();
	int index  = list.GetCurSel();
	if(index  != LB_ERR) {
		list.DeleteString(index);
		if(index >= list.GetCount())
			index = list.GetCount() - 1;
		list.SetCurSel(index);
	}
}

void CSortDialog::OnListUp() 
{
	// TODO: Add your command handler code here
	CListBox& list = GetListBox();
	int index  = list.GetCurSel();
	if(index != LB_ERR && index > 0) {
		CString sItem;
		list.GetText(index, sItem);
		list.DeleteString(index);
		list.InsertString(index - 1, sItem);
		list.SetCurSel(index - 1);
	}
}

void CSortDialog::OnListDown() 
{
	// TODO: Add your command handler code here
	CListBox& list = GetListBox();
	int index  = list.GetCurSel();
	if(index != LB_ERR && index < list.GetCount() - 1) {
		CString sItem;
		list.GetText(index, sItem);
		list.DeleteString(index);
		list.InsertString(index + 1, sItem);
		list.SetCurSel(index + 1);
	}
}

void CSortDialog::OnOK() 
{
	// TODO: Add extra validation here
	CListBox& list = GetListBox();
	m_psarrList->RemoveAll();
	for_to(i, list.GetCount()) {
		CString sItem;
		list.GetText(i, sItem);
		m_psarrList->Add(sItem);
	}

	CDialog::OnOK();
}

BOOL CSortDialog::PreTranslateMessage(MSG* pMsg) 
{
	// TODO: Add your specialized code here and/or call the base class
	if(pMsg->message == WM_KEYDOWN) {
		if(pMsg->wParam == VK_DELETE) {
			PostMessage(WM_COMMAND, ID_LIST_DELETE);
			return TRUE;
		}
	}
	else if(pMsg->message == WM_SYSKEYDOWN) {
		if(pMsg->wParam == VK_UP && ::GetKeyState(VK_MENU) < 0)	{
			PostMessage(WM_COMMAND, ID_LIST_UP);
			return TRUE;
		}
		if(pMsg->wParam == VK_DOWN && ::GetKeyState(VK_MENU) < 0)	{
			PostMessage(WM_COMMAND, ID_LIST_DOWN);
			return TRUE;
		}
	}	
	return CDialog::PreTranslateMessage(pMsg);
}
