// ZBFileOp.cpp : implementation file
//

#include "stdafx.h"
#include "ZBrowse.h"
#include "FTP.h"
#include "ZBFileOp.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFileOpDlg dialog


CFileOpDlg::CFileOpDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFileOpDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFileOpDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_bCanceled = FALSE;
	m_bInit = FALSE;
	m_nPos = -1;
	m_dwlTotalBytes = m_dwlDoneBytes = 0;
}


void CFileOpDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFileOpDlg)
	DDX_Control(pDX, IDS_PATH, m_stPath);
	DDX_Control(pDX, IDS_FILENAME, m_stFileName);
	DDX_Control(pDX, IDS_FILENAME2, m_stFileName2);
	DDX_Control(pDX, IDS_COUNTER, m_stCounter);
	DDX_Control(pDX, IDS_REMAIN, m_stRemain);
	DDX_Control(pDX, IDC_PROGRESS, m_progress);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CFileOpDlg, CDialog)
	//{{AFX_MSG_MAP(CFileOpDlg)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDB_CANCEL, OnCancel)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFileOpDlg message handlers

#define PROG_MAX 256
#define IDTIMER 2
#define TIMER_ELAPSE 1000
#define KB_SHIFT 10

BOOL CFileOpDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	m_progress.SetRange(0, PROG_MAX);
	m_progress.ShowWindow(SW_HIDE);
	SetTimer(IDTIMER, TIMER_ELAPSE, NULL);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


void CFileOpDlg::PostNcDestroy() 
{
	// TODO: Add your specialized code here and/or call the base class
	
	delete this;
}

void CFileOpDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	ShowWindow(SW_SHOW);
	int nTotalKB = (int)(m_dwlTotalBytes >> KB_SHIFT);
	int nDoneKB  = (int)(m_dwlDoneBytes  >> KB_SHIFT);

	if(m_bInit || nTotalKB <= 0 || nDoneKB <= 0) return;
	DWORD dwTick = ::GetTickCount();
	if(dwTick < m_dwTickStart) {
		m_dwTickStart = dwTick;
		return;
	}
	int nTickRemain = MulDiv(dwTick - m_dwTickStart, nTotalKB - nDoneKB, nDoneKB);
	if(nTickRemain > 0) {
		nTickRemain /= 1000;
		CString sMsg;
		sMsg.Format(IDS_OPERATE_REMAIN, nTickRemain / 60, nTickRemain % 60);
		m_stRemain.SetWindowText(sMsg);
	}
}

void CFileOpDlg::OnCancel() 
{
	// TODO: Add your control notification handler code here
	m_bCanceled = TRUE;
}

void CFileOpDlg::DrawPath(CString sSrcPath, CString sDstPath)
{
	if(m_bInit) return;
	if(!sDstPath.IsEmpty()) {
		sSrcPath += _T(" --> ") + sDstPath;
	}
	m_stPath.SetWindowText(sSrcPath);
	m_stFileName.SetWindowText(_T(""));
	m_stFileName2.SetWindowText(_T(""));
	// m_progress.ShowWindow(SW_HIDE);
	// m_stCounter.SetWindowText("");
}

void CFileOpDlg::DrawFileName(LPCTSTR pFileName)
{
	if(m_bInit) return;
	m_stFileName.SetWindowText(pFileName);
}

void CFileOpDlg::DrawFileName2(LPCTSTR pFileName)
{
	if(m_bInit) return;
	m_stFileName2.SetWindowText(pFileName);
}

void CFileOpDlg::DrawStatus(DWORDLONG dwlTotalBytes, DWORDLONG dwlDoneBytes, int nTotlaFiles, int nDoneFiles)
{
	if(m_bInit) return;
	DrawStatus(dwlTotalBytes, dwlDoneBytes);
	CString sCounter;
	if(nTotlaFiles)
		sCounter.Format(_T("%d/%d"), nDoneFiles, nTotlaFiles);
	else
		sCounter.Format(_T("%d"), nDoneFiles);
	m_stCounter.SetWindowText(sCounter);
}

void CFileOpDlg::DrawStatus(DWORDLONG dwlTotalBytes, DWORDLONG dwlDoneBytes)
{
	if(m_bInit) return;
	// m_progress.ShowWindow(SW_SHOW);
	m_dwlTotalBytes = dwlTotalBytes;
	m_dwlDoneBytes = dwlDoneBytes;

	int nPos = dwlTotalBytes ? (int)(dwlDoneBytes * PROG_MAX / dwlTotalBytes) : PROG_MAX;
	if(nPos != m_nPos) {
		m_nPos = nPos;
	//	dwTotalBytes /= 16;
	//	dwDoneBytes /= 16;
		m_progress.SetPos(nPos);
	}
}

void CFileOpDlg::SetInitializeMode(BOOL bInit)
{
	m_bInit = bInit;
	if(bInit) {
		CString sMsg;
		sMsg.LoadString(IDS_OPERATE_INIT);
		m_stFileName.SetWindowText(sMsg);
		m_progress.ShowWindow(SW_HIDE);
	}
}

void CFileOpDlg::StartOperation(BOOL bShowProgress)
{
	m_progress.ShowWindow(bShowProgress ? SW_SHOW : SW_HIDE);
	m_dwTickStart = ::GetTickCount();
}


/////////////////////////////////////////////////////////////////////////////
// HDROP utils

int HDropGetCount(HDROP hDrop)
{
	TCHAR buff[MAX_PATH];
	return ::DragQueryFile(hDrop, UINT_MAX, buff, MAX_PATH);
}

CFileName HDropGetFileName(HDROP hDrop, int i)
{
	CString sFile;
	LPTSTR pBuff = sFile.GetBuffer(MAX_PATH);
	::DragQueryFile(hDrop, i, pBuff, MAX_PATH);
	sFile.ReleaseBuffer();
	return sFile;
}

/////////////////////////////////////////////////////////////////////////////
// File Operation

TCHAR *sOpMode[5] = { _T("Move"), _T("Copy"), _T("Delete"), _T("Rename"), _T("Compare") };
FileOpParam m_fileOp;

void FileOpParam::Start(DWORD _dwBytesPerCluster)
{
	pDlg = new CFileOpDlg;
	BOOL bResult = pDlg->Create(wFunc != FO_COMPARE ? IDD_OPERATION : IDD_OPERATION2);
	dwBytesPerCluster = _dwBytesPerCluster;
	AfxBeginThread(ZBFileOpThread, (LPVOID)this);
}

UINT ZBFileOpThread(LPVOID pParam)
{
	FileOpParam* pFOp = (FileOpParam*)pParam;

	CZBFileOp fileop;
	fileop.Start(pFOp);

	if(pFOp->hDrop)
		::GlobalFree(pFOp->hDrop);
	pFOp->dwlDoneFileBytes = fileop.m_dwlDoneBytes;
	pFOp->dwlDoneDiskBytes = fileop.m_dwlDoneDiskBytes;

	::PostMessage(pFOp->hwnd, WM_FILEOP_COMPLETE, fileop.m_bDone, 0);
	return 1;
}

CZBFileOp::CZBFileOp()
{
	m_flags = 0;
}

void CZBFileOp::Start(FileOpParam* pFOp)
{
	if(Init(pFOp)) {
		if(m_bValidTotal) {
			pFOp->pDlg->SetInitializeMode(TRUE);
			UINT wFunc = m_wFunc;
			m_wFunc = FO_DUMMY;
			if(!Operate(pFOp)) return;
			pFOp->pDlg->SetInitializeMode(FALSE);
			m_wFunc = wFunc;
			SetTotalParameters();
		}
		pFOp->pDlg->StartOperation(m_bValidTotal);
		Operate(pFOp);
	}
}

BOOL CZBFileOp::Operate(FileOpParam* pFOp)
{
	if(pFOp->hDrop) {
		if(!pFOp->pFinder)
			return Operate(pFOp->hDrop);
		else
			return Operate(pFOp->pFinder);
	} else
		return OperateByFindPair(pFOp->findPair);
}

BOOL CZBFileOp::Init(FileOpParam* pFOp)
{
	CFileName sSrcFile = pFOp->hDrop ? HDropGetFileName(pFOp->hDrop) : pFOp->sSrcDir;
	m_sSrcDir = pFOp->sSrcDir;	// ###1.20
	m_sDstDir = pFOp->sDstDir;
	m_wFunc = pFOp->wFunc;
	m_sOpMode = sOpMode[pFOp->wFunc - FO_MOVE];
	m_pDlg = pFOp->pDlg;
	m_pDlg->SetWindowText(m_sOpMode);
#ifndef NO_FTP
	if (ftp.IsFTPPath(sSrcFile)) m_flags |= FOP_SRCFTP;
	if(ftp.IsFTPPath(m_sDstDir)) m_flags |= FOP_DSTFTP;
	if(m_flags & FOP_FTP) {
		CString sServer, sPath;
		if(!ftp.ParseURL((m_flags & FOP_SRCFTP) ? sSrcFile : m_sDstDir, sServer, sPath))
			return FALSE;
		if(!ftp.Connect(ftp.FindServer(sServer), 0, TRUE))
			return FALSE;
		if(m_flags & FOP_SRCFTP)
			m_fileSrc.m_hFTP = ftp.m_hFTP;
		if(m_flags & FOP_DSTFTP) {
			m_fileDst.m_hFTP = ftp.m_hFTP;
			m_sDstDir = ftp.GetRoot(m_sDstDir);
		}
	} else {
#endif
		if (m_wFunc == FO_MOVE && sSrcFile.GetDrive() == m_sDstDir.GetDrive())
			m_wFunc = FO_RENAME;
#ifndef NO_FTP
	}
#endif
	m_bValidTotal = (m_wFunc == FO_COPY || m_wFunc == FO_MOVE || m_wFunc == FO_COMPARE);

	m_dwBuffer = ((m_flags & FOP_FTP) ? options.m_dwBufferFTP : options.m_dwBuffer) * 1024;
	InitFileOp();
	m_dwBytesPerCluster = pFOp->dwBytesPerCluster;	// ###1.20
	return TRUE;
}

void CZBFileOp::DrawStatus(DWORDLONG dwlDoneBytes)
{
	if(m_wFunc == FO_DUMMY || !m_bValidTotal) return;
	if(m_dwlTotalBytes)
		m_pDlg->DrawStatus(m_dwlTotalBytes, (m_dwBytesPerCluster ? m_dwlDoneDiskBytes : m_dwlDoneBytes) + dwlDoneBytes, m_nTotalFiles, m_nDoneFiles);
	else
		m_pDlg->DrawStatus(m_dwlSubTotalBytes, m_dwlSubDoneBytes + dwlDoneBytes, m_nSubTotlaFiles, m_nSubDoneFiles);
}

BOOL CZBFileOp::AllocBuffer()	// ###1.20
{
	if(!m_pBuffer) {
		m_pBuffer = MemAlloc(m_dwBuffer);
	}
	if(m_wFunc == FO_COMPARE && !m_pBuffer2) {
		m_pBuffer2 = MemAlloc(m_dwBuffer);
	}
	return m_pBuffer != NULL;
}

BOOL CZBFileOp::Operate(HDROP hDrop)
{
	BOOL bResult = TRUE;
	int nCount = HDropGetCount(hDrop);
	CFileName sPath = HDropGetFileName(hDrop);
#ifndef NO_FTP
	if (m_flags & FOP_SRCFTP)
		sPath = ftp.GetRoot(sPath);
#endif
	if(m_wFunc == FO_DUMMY && InitTotalDiskBytes(sPath)) return TRUE;
	if(nCount == 1) {
		if(sPath.IsRoot())
			bResult = OperateDir(sPath, m_sDstDir);		// ###1.20
		else
			bResult = OperateFind(sPath);
	} else {
		CFTPFindFiles finder;
		sPath.GetParentDirectory();
		VERIFY(finder.FindAll(sPath, m_fileSrc.m_hFTP, FIND_DIRFILE));
		for_to(i, nCount) {
			CFileName sFile = HDropGetFileName(hDrop, i);
#ifndef NO_FTP
			if (m_flags & FOP_SRCFTP)
				sFile = ftp.GetRoot(sFile);
#endif
			int iFind = finder.SearchFile(sFile);
			if(iFind == INVALID)
				bResult = OperateFind(sFile);
			else {
				finder[iFind].SetMark();
			}
		}
		bResult = OperateDir(sPath, m_sDstDir, &finder);
	}
	return bResult;
}

BOOL CZBFileOp::Operate(CFTPFindFiles* pFinder)
{
	return OperateDir(pFinder->GetFindDir(), m_sDstDir, pFinder);
}

BOOL CZBFileOp::OperateByFindPair(CArray<FindDataPair, FindDataPair&>& findPair)
{
	m_pDlg->DrawPath(m_sSrcDir, m_sDstDir);
	InitSubCounter();
	for_to(i, findPair.GetSize()) {
		m_nSubTotlaFiles++;
		m_dwlSubTotalBytes += findPair[i].pDataSrc->dwlSize;
	}
	for_to_(i, findPair.GetSize()) {
		if(!OperateFile(m_sSrcDir, m_sDstDir, findPair[i].pDataSrc, findPair[i].pDataDst)) return FALSE;
	}
	return TRUE;
}

BOOL CZBFileOp::OperateDefault(UINT wFunc, LPCTSTR pSrcFile, LPCTSTR pDstFile, CFindData* pSrcData, CFindData* pDstData)
{
	if(wFunc == FO_COMPARE) {
		BOOL bResult = TRUE;
		BOOL bMismatch = TRUE;
		if(pSrcData->dwlSize == pDstData->dwlSize) {
			int nResult = CompareFile(pSrcFile, pDstFile);
			bResult = (nResult != 0);
			if(nResult == TRUE) bMismatch = FALSE;
		}
		if(bMismatch)
			pDstData->SetMark();
		return bResult;
	}
	return CFTPFileOp::OperateDefault(wFunc, pSrcFile, pDstFile, pSrcData, pDstData);
}

BOOL CZBFileOp::OperateFind(LPCTSTR pPath)
{
	CFTPFindFiles finder;
	VERIFY(finder.FindFile(pPath, m_fileSrc.m_hFTP));
	CFindData& src = finder[0];
	InitSubCounter();
	if(src.IsDirectory()) {
		CFileName sDstDir = m_fileDst.AddPath(m_sDstDir, src.GetFileName());
		if(m_wFunc == FO_RENAME)
			return FileOperate(m_wFunc, pPath, sDstDir);
		else 
			return OperateDir(pPath, sDstDir);
	} else {
		m_nSubTotlaFiles = 1;
		m_dwlSubTotalBytes = src.dwlSize;
		m_sSrcDir = CFileName(pPath);
		VERIFY(m_sSrcDir.GetParentDirectory());
		return OperateFile(m_sSrcDir, m_sDstDir, &src);
	}
}

BOOL CZBFileOp::OperateFile(LPCTSTR pSrcDir, LPCTSTR pDstDir, CFindData* pSrcData, CFindData* pDstData)
{
	BOOL bResult = TRUE;
	if(m_wFunc != FO_DUMMY) {
#ifndef NO_FTP
		m_transfer = ftp.m_transfer ? ftp.m_transfer : GetFileType(pSrcData->GetFileName());
#else
		m_transfer = FTP_TRANSFER_TYPE_BINARY;
#endif
		m_pDlg->DrawFileName(pSrcData->GetSubPathName(m_fileSrc.IsFTP()));	// ###1.20
		if(m_wFunc == FO_COMPARE)
			m_pDlg->DrawFileName2(pDstData->GetSubPathName(m_fileDst.IsFTP()));
		DrawStatus();
		bResult = FileOperate(m_wFunc, pSrcDir, pDstDir, pSrcData, pDstData);
	}
	if(bResult) {
		m_dwlSubDoneBytes += pSrcData->dwlSize;
		m_nSubDoneFiles++;
		m_dwlDoneBytes += pSrcData->dwlSize;
		m_nDoneFiles++;
		if(m_dwBytesPerCluster) // ###1.20
			m_dwlDoneDiskBytes += ((pSrcData->dwlSize + (m_dwBytesPerCluster - 1)) & ~(m_dwBytesPerCluster-1));
		DrawStatus();
	}
	return bResult;
}

BOOL CZBFileOp::OperateDir(LPCTSTR pSrcDir, LPCTSTR pDstDir, CFTPFindFiles* pFinder)
{
	CStringArray sSubdirs;
	m_pDlg->DrawPath(pSrcDir, pDstDir);
	BOOL bFind = (pFinder == NULL);
	if(bFind) {
		pFinder = &m_finder;
FindSrc:
		if(!pFinder->FindAll(pSrcDir, m_fileSrc.m_hFTP, FIND_DIRFILE)) {
			if(ErrorMessageBox(pSrcDir) == IDRETRY) goto FindSrc;
			m_bError = TRUE;
			Cancel();
		}
		if(IsCanceled()) return FALSE;
	}
	InitSubCounter();
	for_to(i, pFinder->GetCount()) {
		CFindData& src = pFinder->ElementAt(i);
		if(bFind || src.IsMarked()) {
			if(src.IsDirectory())
				sSubdirs.Add(src.GetFileName());
			else {
				m_dwlSubTotalBytes += src.dwlSize;
				m_nSubTotlaFiles ++;
			}
		}
	}
	if(m_wFunc == FO_COPY || m_wFunc == FO_MOVE || m_wFunc == FO_RENAME)
		CreateDirectory(pDstDir, pSrcDir);		// ###0.93
	if(m_nSubTotlaFiles) {
		for_to_(i, pFinder->GetCount()) {
			CFindData& src = pFinder->ElementAt(i);
			if(bFind || src.IsMarked()) {
				if(!src.IsDirectory()) {
					BOOL bOperate = OperateFile(pSrcDir, pDstDir, &src);
					if(IsCanceled()) return FALSE;
				}
			}
		}	
	}
	if(bFind)
		pFinder->RemoveAll();

	for_to_(i, sSubdirs.GetSize()) {
		CFileName sSrcDir = m_fileSrc.AddPath((CFileName)pSrcDir, sSubdirs[i]);
		CFileName sDstDir = m_fileDst.AddPath((CFileName)pDstDir, sSubdirs[i]);
		OperateDir(sSrcDir, sDstDir);
		if(IsCanceled()) return FALSE;
	}
	if(bFind && (m_wFunc == FO_DELETE || m_wFunc == FO_MOVE || m_wFunc == FO_RENAME)) {
		FileOperate(FO_DELETE, pSrcDir);
	}
	return TRUE;
}
