#if !defined(AFX_ZBFILEOP_H__6953DD42_AC3A_11D2_AEBE_00400533897F__INCLUDED_)
#define AFX_ZBFILEOP_H__6953DD42_AC3A_11D2_AEBE_00400533897F__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// ZBFileOp.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CFileOpDlg dialog

class CFileOpDlg : public CDialog
{
// Construction
public:
	CFileOpDlg(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CFileOpDlg)
	enum { IDD = IDD_OPERATION };
	CStatic	m_stPath;
	CStatic	m_stFileName;
	CStatic	m_stFileName2;
	CStatic	m_stCounter;
	CStatic	m_stRemain;
	CProgressCtrl m_progress;
	//}}AFX_DATA

public:
	void DrawPath(CString sSrcPath, CString sDstPath);
	void DrawFileName(LPCTSTR pFileName);
	void DrawFileName2(LPCTSTR pFileName);
	void DrawStatus(DWORDLONG dwlTotalBytes, DWORDLONG dwlDoneBytes, int nTotlaFiles, int nDoneFiles);
	void DrawStatus(DWORDLONG dwlTotalBytes, DWORDLONG dwlDoneBytes);
	void SetInitializeMode(BOOL bInit);
	void StartOperation(BOOL bShowProgress = TRUE);

public:
	BOOL m_bCanceled;
private:
	BOOL m_bInit;
	int  m_nPos;
	DWORD m_dwTickStart;
	DWORDLONG m_dwlTotalBytes;
	DWORDLONG m_dwlDoneBytes;

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CFileOpDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual void PostNcDestroy();
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CFileOpDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnCancel();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
// File Operation

#include "FTPFile.h"

struct FindDataPair
{
	CFindData *pDataSrc;
	CFindData *pDataDst;
};

class FileOpParam
{
public:
	HWND hwnd;
	UINT wFunc; // FO_MOVE, FO_COPY, FO_DELETE, FO_COMPARE
	HDROP hDrop;
	CString sSrcDir;								// ###1.20
	CString sDstDir;
	CFTPFindFiles* pFinder;
	CArray<FindDataPair, FindDataPair&> findPair;	// ###1.20
	DWORDLONG dwlDoneDiskBytes;
	DWORDLONG dwlDoneFileBytes;
	DWORD dwBytesPerCluster;
	CFileOpDlg* pDlg;
	void Start(DWORD _dwBytesPerCluster = 0);
};

extern FileOpParam m_fileOp;

#define FOP_SRCFTP  0x1000
#define FOP_DSTFTP  0x2000
#define FOP_FTP (FOP_SRCFTP | FOP_DSTFTP)

class CZBFileOp : public CFTPFileOp
{
public:
	CZBFileOp();
	void Start(FileOpParam* pFOp);
	BOOL Init(FileOpParam* pFOp);
	BOOL Operate(FileOpParam* pFOp);
	BOOL Operate(HDROP hDrop);
	BOOL Operate(CFTPFindFiles* pFinder);
	BOOL OperateByFindPair(CArray<FindDataPair, FindDataPair&>& findPair);
	BOOL OperateFile(LPCTSTR pSrcDir, LPCTSTR pDstDir, CFindData* pSrcData, CFindData* pDstData = NULL);
	BOOL OperateDir(LPCTSTR pSrcDir, LPCTSTR pDstDir, CFTPFindFiles* pFinder = NULL);
	BOOL OperateFind(LPCTSTR pPath);
	virtual BOOL OperateDefault(UINT wFunc, LPCTSTR pSrcFile, LPCTSTR pDstFile, CFindData* pSrcData, CFindData* pDstData);
	virtual void Cancel() { m_pDlg->m_bCanceled = TRUE; }
	virtual BOOL IsCanceled() { return m_pDlg->m_bCanceled; }
	virtual void DrawStatus(DWORDLONG dwlDoneBytes = 0);
	virtual BOOL AllocBuffer();		// ###1.20
public:
	CFTPFindFiles m_finder;
	CFileName m_sSrcDir;
	CFileName m_sDstDir;
	UINT m_flags;
	UINT m_wFunc;
	BOOL m_bValidTotal;
	CFileOpDlg* m_pDlg;
};

UINT ZBFileOpThread(LPVOID pParam);
int HDropGetCount(HDROP hDrop);
CFileName HDropGetFileName(HDROP hDrop, int i=0);

#define WM_FILEOP_COMPLETE (WM_USER + 20)

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ZBFILEOP_H__6953DD42_AC3A_11D2_AEBE_00400533897F__INCLUDED_)
