// ZBrowse.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "ZBrowse.h"

#include "MainFrm.h"
#include "ZBrDoc.h"
#include "ZBTreeVw.h"
#include "ZBListVw.h"
#include "FTP.h"
#include "zczb.h"
#include "hlp\topics.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CZBOptions options;

/////////////////////////////////////////////////////////////////////////////
// CZBrowseApp

BEGIN_MESSAGE_MAP(CZBrowseApp, CWinApp)
	//{{AFX_MSG_MAP(CZBrowseApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_COMMAND(ID_BROWSE_OK, OnBrowseOK)
	ON_COMMAND(ID_BROWSE_CANCEL, OnBrowseCancel)
	ON_COMMAND(ID_FILE_ENTER, OnBrowseOK)
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	ON_COMMAND( ID_HELP, OnHelp ) 
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CZBrowseApp construction

CZBrowseApp::CZBrowseApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
	EnableHtmlHelp();
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CZBrowseApp object

CZBrowseApp theApp;

/////////////////////////////////////////////////////////////////////////////
// class CZBCommandLineInfo

class CZBCommandLineInfo : public CCommandLineInfo
{
public:
	virtual void ParseParam(const TCHAR* pszParam, BOOL bFlag, BOOL bLast);
};

void CZBCommandLineInfo::ParseParam(const TCHAR* pszParam, BOOL bFlag, BOOL bLast)
{
	if (!_tcsnicmp(pszParam, _T("caption"), 7))
		options.m_sCaption = CString(pszParam + 8);
	else if (!_tcsnicmp(pszParam, _T("id"), 2))
		options.m_nBrowse = _ttoi(pszParam + 3);
	else if (!_tcsnicmp(pszParam, _T("root"), 4))
		options.m_sBrowseFolder = CString(pszParam + 5);
}

/////////////////////////////////////////////////////////////////////////////
// CZBrowseApp initialization

extern LPMALLOC g_pMalloc;

BOOL CZBrowseApp::InitInstance()
{
	// Initialize OLE libraries
	if (!AfxOleInit())
	{
		AfxMessageBox(IDP_OLE_INIT_FAILED);
		return FALSE;
	}

	m_bFirstInstance = ::FindWindow(sZBrowseClassName, NULL) == NULL;

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

//#ifdef _AFXDLL
//	Enable3dControls();			// Call this when using MFC in a shared DLL
//#else
//	Enable3dControlsStatic();	// Call this when linking to MFC statically
//#endif

	// Change the registry key under which our settings are stored.
	// You should modify this string to be something appropriate
	// such as the name of your company or organization.
	SetRegistryKey(_T("c.mos"));
	free((void*)m_pszProfileName);
	m_pszProfileName = _tcsdup(_T("ZCopy"));

	LPCTSTR pPath = _tcsrchr(m_pszHelpFilePath, TCHAR('\\'));
	if(pPath) {
		CString sHelpPath = CString(m_pszHelpFilePath, pPath - m_pszHelpFilePath + 1);
		sHelpPath += _T("zcopy.chm::/html/zcopy_zbrowse.htm");
		free((void*)m_pszHelpFilePath);
		m_pszHelpFilePath = _tcsdup(sHelpPath);
	}

	LoadStdProfileSettings();  // Load standard INI file options (including MRU)
	options.Load();
#ifndef NO_FTP
	ftp.Load();
#endif

	::SHGetMalloc(&g_pMalloc);

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	CSingleDocTemplate* pDocTemplate;
	pDocTemplate = new CSingleDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CZBrowseDoc),
		RUNTIME_CLASS(CMainFrame),       // main SDI frame window
		RUNTIME_CLASS(CZBTreeView));
	AddDocTemplate(pDocTemplate);

	// Parse command line for standard shell commands, DDE, file open
	CZBCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	options.LoadFramePos();

	// Dispatch commands specified on the command line
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;

	// The one and only window has been initialized, so show and update it.
	m_pMainWnd->ShowWindow(options.m_bMaximized ? SW_SHOWMAXIMIZED : SW_SHOW);
	m_pMainWnd->UpdateWindow();

	return TRUE;
}

BOOL CZBrowseApp::MessageLoop()
{
/*	MSG msg;
	while(::PeekMessage(&msg, NULL, 0, 0, PM_NOREMOVE)) {
		if(!::GetMessage(&msg, NULL, 0, 0)) {
			AfxPostQuitMessage(msg.wParam);
			return FALSE;
		}
		::TranslateMessage(&msg);
		::DispatchMessage(&msg);
	}
	return TRUE;
*/

	MSG msg;
	while(::PeekMessage(&msg, NULL, 0, 0, PM_NOREMOVE)) {
		if(!PumpMessage()) {
			AfxPostQuitMessage(msg.wParam);
			return FALSE;
		} 
	} 
	// let MFC do its idle processing
	LONG lIdle = 0;
	while(AfxGetApp()->OnIdle(lIdle++)) ;
	return TRUE;

/*	while (::PeekMessage(&msg, NULL, 0, 0, PM_NOREMOVE)){
		if(msg.message == WM_PAINT)
			TRACE("MSG:%d\n", msg.message);
		if (!AfxGetThread()->PumpMessage()){
			AfxPostQuitMessage(msg.wParam);
			return;
		}
	}
*/
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CZBrowseApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

void CZBrowseApp::OnHelp()
{
	//WinHelp(HID_ZBROWSE);
	HtmlHelp(NULL, HH_DISPLAY_TOPIC);
}

/////////////////////////////////////////////////////////////////////////////
// CZBrowseApp commands

int CZBrowseApp::ExitInstance() 
{
	// TODO: Add your specialized code here and/or call the base class
	if(g_pMalloc) g_pMalloc->Release();
	options.Save();
	return CWinApp::ExitInstance();
}

BOOL CZBrowseApp::SaveAllModified() 
{
	// TODO: Add your specialized code here and/or call the base class
	GetMainFrame()->GetFrameState();
	options.Save();
	return CWinApp::SaveAllModified();
}

CZBOptions::CZBOptions()
{
	m_nBrowse = 0;
}

void CZBOptions::Load()
{
	m_sBrowseFolder = GetProfileString(_T("BrowseFolder"));
	m_dwBuffer = GetProfileInt(_T("BufferSize"), 1024); 
	m_dwBufferFTP = GetProfileInt(_T("BufferSizeFTP"), 32); 
	m_nHistMax = GetProfileInt(_T("HistoryCount"), 10);
	m_viewStyle = GetProfileInt(_T("ViewStyle"), LVS_REPORT);
	m_bFlatBar = GetProfileInt(_T("FlatToolBar"), TRUE);
	m_iNetWalk = GetProfileInt(_T("NetWalk"), 0);
	m_nSnap = GetProfileInt(_T("Snap"), 10);
	LoadHistory(CString(_T("Browse")), m_sHistPath);
	LoadHistory(CString(_T("Favor")), m_sFavorPath);
	LoadHistory(CString(_T("Thumb")), m_sThumbPath);
	LoadListView();
}

void CZBOptions::LoadFramePos()
{
	CString sRegFrame;
	sRegFrame.Format(_T("Frame%d"), m_nBrowse);
	SetSection(sRegFrame);
	m_rFrame.left = GetProfileInt(_T("XPos"), 0); 
	m_rFrame.top = GetProfileInt(_T("YPos"), 0); 
	m_rFrame.right = m_rFrame.left + GetProfileInt(_T("Width"), 0); 
	m_rFrame.bottom = m_rFrame.top + GetProfileInt(_T("Height"), 0);
	m_cxSplit = GetProfileInt(_T("SplitPos"), 200);
	m_bMaximized = GetProfileInt(_T("Maximized"), FALSE); 
	m_barState = GetProfileInt(_T("BarState"), BARSTATE_TOOL | BARSTATE_STATUS);
	m_snapflag = GetProfileInt(_T("SnapFlag"), FALSE); 
	SetSection();
}

void CZBOptions::Save()
{
	if(m_nBrowse == 0)
		WriteProfileString(_T("BrowseFolder"), m_sBrowseFolder);
	WriteProfileInt(_T("ViewStyle"), m_viewStyle);
	WriteProfileInt(_T("FlatToolBar"), m_bFlatBar);
	WriteProfileInt(_T("NetWalk"), m_iNetWalk);
	WriteProfileInt(_T("Snap"), m_nSnap);

	CString sRegFrame;
	sRegFrame.Format(_T("Frame%d"), m_nBrowse);
	SetSection(sRegFrame);
	WriteProfileInt(_T("XPos"), m_rFrame.left); 
	WriteProfileInt(_T("YPos"), m_rFrame.top);
	WriteProfileInt(_T("Width"), m_rFrame.Width()); 
	WriteProfileInt(_T("Height"), m_rFrame.Height());
	WriteProfileInt(_T("SplitPos"), m_cxSplit);
	WriteProfileInt(_T("Maximized"), m_bMaximized);
	WriteProfileInt(_T("BarState"), m_barState);
	WriteProfileInt(_T("SnapFlag"), m_snapflag);
	SetSection();

	SaveHistory(CString(_T("Browse")), m_sHistPath);
	SaveHistory(CString(_T("Favor")), m_sFavorPath);
	SaveHistory(CString(_T("Thumb")), m_sThumbPath);
	SaveListView();
}

void CZBrowseApp::OnBrowseOK()
{
	if(options.m_nBrowse) {
		CWnd* pwndZCopy = CWnd::FindWindow(NULL, _T("ZCopy"));
		if(pwndZCopy) {
			WriteProfileString(sRegDefault, sRegFolder, GetMainFrame()->m_sFolder);
			pwndZCopy->PostMessage(WM_BROWSE_FOLDER, options.m_nBrowse);
		}
		GetMainFrame()->PostMessage(WM_CLOSE);
	}
}

void CZBrowseApp::OnBrowseCancel() 
{
	// TODO: Add your command handler code here
	if(options.m_nBrowse)
		GetMainFrame()->PostMessage(WM_CLOSE);
}
