/////////////////////////////////////////////////////////////////////////////
// ZCFind.h

#ifndef ZCFIND_H
#define ZCFIND_H

#include "FTPFile.h"

class CZCInfo;
class CLogDlg;

struct IncExcArray
{
	CStringArray sInc;
	CStringArray sExc;
};

class CZCFind : public CFTPFindFiles, public CFTPFileOp
{
public:
	CZCFind(CLogDlg* pLogDlg);
	~CZCFind();
	CZCInfo* m_pInfo;
	CLogDlg* m_pLogDlg;
	BOOL m_bExec;
	CString m_sSrcPath;
	CString m_sDstPath;
	IncExcArray m_Masks;
	IncExcArray m_Dirs;
	IncExcArray m_Paths;
	UINT  m_maskstate;
	int m_nFileCount;
	BOOL m_bDummy;		// ###1.20
	BOOL m_bValidTotal;
public:
	void ScanDir(LPCTSTR pDir);
	void ScanDir();		// ###1.23
	BOOL Init();
	BOOL Done();
	virtual BOOL PostFind(CFindData* pData);
	void CalcTotalBytes();	// ###1.20
private:
	CFTPFindFiles m_finderDest;
//	LPVOID m_pBuffer2;		###1.20 --> CFTPFileOp
	BOOL m_bDest;
	BOOL m_bLogOut;
	UINT m_movemode;
	CString m_sLogMsg;
	BOOL m_bDeleteOnSync;	// ###1.22
	DWORDLONG m_dwlBySize;	// ###1.23

	BOOL Operate(OpMode opmode, LPCTSTR pSrcDir, LPCTSTR pDstDir= NULL, CFindData* pSrcData = NULL, CFindData* pDstData = NULL);
	virtual BOOL OperateDefault(UINT wFunc, LPCTSTR pSrcDir, LPCTSTR pDstDir, CFindData* pSrcData, CFindData* pDstData);
	void ParseMask(LPCTSTR pMask, BOOL bInc); 
	BOOL IsIncExc(CFileName sPath, IncExcArray& arr, UINT mask);
	BOOL CompareFile(LPCTSTR pSrcFile, LPCTSTR pDstFile, CFindData* pSrcData, CFindData* pDstData);
	virtual BOOL AllocBuffer();
	virtual void Cancel() { m_pLogDlg->m_bCanceled = TRUE; }
	virtual BOOL IsCanceled() { return m_pLogDlg->m_bCanceled; }
	virtual void AddLog(CString sText) { m_pLogDlg->AddLog(sText); }
	virtual void DrawStatus(DWORDLONG dwlDoneBytes = 0);
};

#endif //ZCFIND_H


