// ZCopy.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "ZCopy.h"
#include "ZCopyDlg.h"
#include "ZCInfo.h"
#include "hlp\topics.h"
#include "RichCtrl.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CZCOptions options;

/////////////////////////////////////////////////////////////////////////////
// CZCopyApp

BEGIN_MESSAGE_MAP(CZCopyApp, CWinApp)
	//{{AFX_MSG_MAP(CZCopyApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, OnHelp)		// ###0.92
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CZCopyApp construction

CZCopyApp::CZCopyApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
	m_bDoBackup = FALSE;

	EnableHtmlHelp();
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CZCopyApp object

CZCopyApp theApp;

/////////////////////////////////////////////////////////////////////////////
// class CZCCommandLineInfo

class CZCCommandLineInfo : public CCommandLineInfo
{
public:
	virtual void ParseParam(const TCHAR* pszParam, BOOL bFlag, BOOL bLast);
};

void CZCCommandLineInfo::ParseParam(const TCHAR* pszParam, BOOL bFlag, BOOL bLast)
{
	if(bFlag) {
		if (!_tcsicmp(pszParam, _T("backup")))
			theApp.m_bDoBackup = TRUE;
	} else
		theApp.m_sarrCmdline.Add(pszParam);
}

/////////////////////////////////////////////////////////////////////////////
// CZCopyApp initialization

BOOL CZCopyApp::InitInstance()
{
	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

	// Parse command line for standard shell commands, DDE, file open
	CZCCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	if(m_sarrCmdline.GetSize() == 0) {
		CWnd* pWnd = CWnd::FindWindow(NULL, m_pszAppName);
		if(pWnd && ::GetWindowLong(pWnd->GetSafeHwnd(), GWL_USERDATA) == ZC_USER_DATA) {	// ###0.92
			pWnd->PostMessage(WM_COMMAND, m_bDoBackup ? ID_AUTO_BACKUP: ID_TRAY_OPEN);
			return FALSE;
		}
	}

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
//	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif
	SetRegistryKey(_T("c.mos"));
	options.Load();
#ifndef NO_FTP
	ftp.Load();
#endif

	AfxInitRichEdit2();

	CZCopyDlg dlg;
	if(!dlg.Load())	dlg.New();
	m_pMainWnd = &dlg;

	if(m_sarrCmdline.GetSize() || m_bDoBackup) {
		dlg.Create(IDD_ZCOPY_DIALOG);
		if(m_bDoBackup)
			dlg.OnBackup();
		else {
			for_to(i, m_sarrCmdline.GetSize()) {
				for_to(j, dlg.m_arrInfo.GetSize()) {
					CZCInfo* pInfo = dlg.GetInfoPtr(j);
					if(pInfo->m_sLabel.CompareNoCase(m_sarrCmdline[i]) == 0) {
						dlg.OnExec(DO_AUTOEXEC, pInfo);
						break;
					}
				}
			}
		}
		dlg.SaveReport();
		dlg.DestroyWindow();			
		return FALSE;
	}

	int nResponse = dlg.DoModal();
	if (nResponse == IDOK)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with OK
	}
	else if (nResponse == IDCANCEL)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with Cancel
	}
	// Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.
	return FALSE;
}

void CZCOptions::Load()
{
	CWinApp* pApp = AfxGetApp();
	m_bOnTray = pApp->GetProfileInt(sRegDefault, _T("OnTray"), FALSE);
	m_dwBuffer = pApp->GetProfileInt(sRegDefault, _T("BufferSize"), 1024); 
	m_dwBufferFTP = pApp->GetProfileInt(sRegDefault, _T("BufferSizeFTP"), 32); 
	m_bHideDlg = pApp->GetProfileInt(sRegDefault, _T("HideDlg"), FALSE);
	m_nHistMax = pApp->GetProfileInt(sRegDefault, _T("HistoryCount"), 10);
	m_bShellBrowser = pApp->GetProfileInt(sRegDefault, _T("ShellBrowser"), FALSE);
	m_fCompare = pApp->GetProfileInt(sRegDefault, _T("Compare"), OP_CMP_LENGTH | OP_CMP_MISMATCH);
	m_bSchedule = pApp->GetProfileInt(sRegDefault, _T("Schedule"), FALSE);
	m_nHour = pApp->GetProfileInt(sRegDefault, _T("Hour"), 0);
	m_bSaveLog = pApp->GetProfileInt(sRegDefault, _T("SaveLog"), 0);
	m_nSaveLogHist = pApp->GetProfileInt(sRegDefault, _T("SaveLogHist"), 10);
	m_bTabMulti = pApp->GetProfileInt(sRegDefault, _T("TabMulti"), FALSE);
	m_uRoundFT = pApp->GetProfileInt(sRegDefault, _T("RoundFileTime"), 0);
	m_bNoCalcTotal = pApp->GetProfileInt(sRegDefault, _T("NoCalcTotal"), FALSE);
	m_bModified = FALSE;
}

void CZCOptions::Save()
{
	if(!m_bModified) return;
	m_bModified = FALSE;
	CWinApp* pApp = AfxGetApp();
	pApp->WriteProfileInt(sRegDefault, _T("OnTray"), m_bOnTray);
	pApp->WriteProfileInt(sRegDefault, _T("BufferSize"), m_dwBuffer);
	pApp->WriteProfileInt(sRegDefault, _T("BufferSizeFTP"), m_dwBufferFTP);
	pApp->WriteProfileInt(sRegDefault, _T("HideDlg"), m_bHideDlg);
	pApp->WriteProfileInt(sRegDefault, _T("HistoryCount"), m_nHistMax);
	pApp->WriteProfileInt(sRegDefault, _T("ShellBrowser"), m_bShellBrowser);
	pApp->WriteProfileInt(sRegDefault, _T("Compare"), m_fCompare);
	pApp->WriteProfileInt(sRegDefault, _T("Schedule"), m_bSchedule);
	pApp->WriteProfileInt(sRegDefault, _T("Hour"), m_nHour);
	pApp->WriteProfileInt(sRegDefault, _T("SaveLog"), m_bSaveLog);
	pApp->WriteProfileInt(sRegDefault, _T("SaveLogHist"), m_nSaveLogHist);
	pApp->WriteProfileInt(sRegDefault, _T("TabMulti"), m_bTabMulti);
	pApp->WriteProfileInt(sRegDefault, _T("RoundFileTime"), m_uRoundFT);
	pApp->WriteProfileInt(sRegDefault, _T("NoCalcTotal"), m_bNoCalcTotal);
}

void CZCopyApp::OnHelp()
{
	// TODO: Add your control notification handler code here
	// WinHelp(HID_ZCOPY_MAIN);
	HtmlHelp(NULL, HH_DISPLAY_TOPIC);
}

BOOL CZCopyApp::LoadSavePrivate(BOOL bSave) //###1.21
{
	BOOL bResult = TRUE;
	CString sProfile = GetModulePath(_T("zcopy.ini"));
	free((void*)m_pszProfileName);
	m_pszProfileName = _tcsdup(sProfile);
	free((void*)m_pszRegistryKey);
	m_pszRegistryKey = NULL;
	CZCopyDlg& dlg = *((CZCopyDlg*)m_pMainWnd);

	if(bSave) {
		options.Touch();
		options.Save();
#ifndef NO_FTP
		ftp.Save();
#endif
		dlg.Touch();
		dlg.Save();
	} else {
		options.Load();
#ifndef NO_FTP
		ftp.Load();
#endif
		if(dlg.Load()) {
			dlg.Init();
			options.Touch();
			dlg.Touch();
		}
		else
			bResult = FALSE;
	}

	SetRegistryKey(_T("c.mos"));
	free((void*)m_pszProfileName);
	m_pszProfileName = _tcsdup(m_pszAppName);

#ifndef NO_FTP
	if (!bSave && bResult)
		ftp.Save();
#endif
	return bResult;
}

CString GetModulePath(LPCTSTR pFileName) 
{
	CString sPath;
	LPTSTR pBuffer = sPath.GetBuffer(_MAX_PATH);
	::GetModuleFileName(NULL, pBuffer, _MAX_PATH - 1);
	TCHAR* p;
	p = _tcsrchr(pBuffer, TCHAR('\\'));
	ASSERT(p);
	*(p+1) = TCHAR('\0');
	sPath.ReleaseBuffer();
	sPath += pFileName;
	return sPath;
}

#define MAX_ENVBUFFER 1024

CString ParseEnv(CString sPath, BOOL bErrMsg)	// ### 1.23
{
	int nStart = 0;
	int nFrom  = -1;
	for(;;) {
		nStart = sPath.Find(TCHAR('%'), nStart);
		if(nStart == -1) break;
		if(nFrom == -1) {
			nFrom = nStart++;
		} else if(nStart - nFrom == 1) {	// '%%'
			sPath.Delete(nStart);
			nFrom = -1;
		} else {
			CString sVarName = sPath.Mid(nFrom + 1, nStart - nFrom - 1);
			CString sBuffer;
			DWORD len = ::GetEnvironmentVariable(sVarName, sBuffer.GetBuffer(MAX_ENVBUFFER), MAX_ENVBUFFER);
			sBuffer.ReleaseBuffer();
			if(len) {
				sPath = sPath.Left(nFrom) + sBuffer + sPath.Mid(nStart + 1);
				nStart = nFrom + sBuffer.GetLength();
				nFrom = -1;
			} else {
				if(bErrMsg) {
					CString sMsg;
					sMsg.Format(IDS_ERR_ENVNOTFOUND, sVarName);
					AfxMessageBox(sMsg);
				}
				return CString(ENV_NOTFOUND);
			}
		}
	}
	return sPath;
}
