// ZCopy.h : main header file for the ZCOPY application
//

#if !defined(AFX_ZCOPY_H__3CE758A4_6C6E_11D1_A5E4_000000000000__INCLUDED_)
#define AFX_ZCOPY_H__3CE758A4_6C6E_11D1_A5E4_000000000000__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#ifndef _ZCOPY
#define _ZCOPY
#endif // _ZCOPY

#include "resource.h"		// main symbols

/////////////////////////////////////////////////////////////////////////////
// CZCopyApp:
// See ZCopy.cpp for the implementation of this class
//

class CZCopyApp : public CWinApp
{
public:
	CZCopyApp();

	CStringArray m_sarrCmdline;
	BOOL m_bDoBackup;

// Operations
public:
	BOOL LoadSavePrivate(BOOL bSave);	// ###1.21

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CZCopyApp)
	public:
	virtual BOOL InitInstance();
	//}}AFX_VIRTUAL
	afx_msg void OnHelp();

// Implementation

	//{{AFX_MSG(CZCopyApp)
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#define OP_CMP_IN_SRC	1
#define OP_CMP_IN_DST	2
#define OP_CMP_EXIST	3
#define OP_CMP_LENGTH	4
#define OP_CMP_MISMATCH	8
#define OP_CMP_TIME		16
#define OP_CMP_IDENTICAL 32

class CZCOptions
{
public:
	BOOL m_bOnTray;
	DWORD m_dwBuffer;
	DWORD m_dwBufferFTP;
	BOOL m_bHideDlg;
	BOOL m_bShellBrowser;
	BOOL m_bIgnoreError;
	int m_nHistMax;
	UINT m_fCompare;
	BOOL m_bSchedule;
	UINT m_nHour;
	BOOL m_bSaveLog;
	int  m_nSaveLogHist;
	BOOL m_bTabMulti;		// ###1.20
	UINT m_uRoundFT;		// ###1.20	
	BOOL m_bNoCalcTotal;	// ###1.21
private:
	BOOL m_bModified;
public:
	void Load();
	void Save();
	void Touch() { m_bModified = TRUE; }
};

extern CZCOptions options;
CString GetModulePath(LPCTSTR pFileName);
inline CString GetLogPath() { return GetModulePath(_T("zcopylog.txt")); }

#define WM_FTP_CONNECT (WM_USER + 10)

#define ENV_NOTFOUND "%%"
CString ParseEnv(CString sPath, BOOL bErrMsg = TRUE);	// ### 1.23

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ZCOPY_H__3CE758A4_6C6E_11D1_A5E4_000000000000__INCLUDED_)
