// ZCopyDlg.h : header file
//

#if !defined(AFX_ZCOPYDLG_H__3CE758A6_6C6E_11D1_A5E4_000000000000__INCLUDED_)
#define AFX_ZCOPYDLG_H__3CE758A6_6C6E_11D1_A5E4_000000000000__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "ZCinfo.h"
#include "TrayIcon.h"
#include "TabCtrl.h"
#include "ComboBox.h"

#define ZC_USER_DATA (long)'ZC'

/////////////////////////////////////////////////////////////////////////////
// CZCopyDlg dialog

class CZCopyDlg : public CDialog, public CZCInfoCtrl
{
// Construction
public:
	CZCopyDlg(CWnd* pParent = NULL);	// standard constructor
	void OnExec(DoMode bExec, CZCInfo *pInfo = NULL);
	void OnBackup() { OnTrayBackup(ID_AUTO_BACKUP); }
	virtual int DoModal();
	void Init();  // ###1.21

// Dialog Data
	//{{AFX_DATA(CZCopyDlg)
	enum { IDD = IDD_ZCOPY_DIALOG };
	CHistComboBox	m_cbSrcPath;
	CHistComboBox	m_cbDstPath;
	CHistComboBox	m_cbIncMask;
	CHistComboBox	m_cbExcMask;
	CTabCtrlEx	m_tabCtrl;
	CStatic	m_stReport;
	int		m_opmode;
	BOOL	m_bInclude;
	BOOL	m_bExclude;
	BOOL	m_bSubDir;
	BOOL	m_bHidden;
	BOOL	m_bNoOVW;
	BOOL	m_bOVW;
	BOOL	m_bByTarget;
	BOOL	m_bBackup;
	BOOL	m_bSrcFTP;
	BOOL	m_bDstFTP;
	BOOL	m_bIgnoreError;
	BOOL	m_bDayAfter;
	BOOL	m_bBySize;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CZCopyDlg)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	void ShowTray(BOOL bShow);
	BOOL CheckServer(CZCInfo* pInfo = NULL);

	void InitTab(BOOL bTouch = FALSE);
	void SetInfo();
	void GetInfo();
	void InitButtons();
	void GetText(CHistComboBox& combo, CString& sText);
	void InitPath(CHistComboBox& combo, BOOL bFTP);
#ifndef NO_FTP
	void InitFTP();
	void Disconnect();
	BOOL FTPSettingDlg();
#endif
	CString Browse(LPCTSTR pPath, BOOL bDest, BOOL bFTP);
	void ResetSheetSize();		// ###1.20
	void ExpandWindow(CWnd* pWnd, int nExpand);
	void InitBackupButton();
	void OnUpdateDayAfter();

	HICON m_hIcon;
	HICON m_hIconSmall;
	CTrayIcon m_trayIcon;
	BOOL m_bShutdown;
	int m_nLastBackupDay;
	int m_nTabRowCount;			// ###1.20

	// Generated message map functions
	//{{AFX_MSG(CZCopyDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnSelchangeTab(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnAddTab();
	afx_msg void OnInclude();
	afx_msg void OnExclude();
	afx_msg void OnRemoveTab();
	afx_msg void OnListing();
	afx_msg void OnClose();
	afx_msg void OnCloseBtn();
	afx_msg void OnReset();
	virtual void OnOK();
	afx_msg void OnSrcBrowse();
	afx_msg void OnDstBrowse();
	afx_msg void OnOption();
	afx_msg void OnShiftLeftTab();
	afx_msg void OnShiftRightTab();
	afx_msg void OnSrcFTP();
	afx_msg void OnDstFTP();
	afx_msg void OnFTPSetting();
	afx_msg void OnConnect();
	afx_msg void OnRenameTab();
	afx_msg void OnOpOption();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnSelChangeOperation();
	afx_msg void OnDoBackup();
	afx_msg void OnCheckBackup();
	afx_msg void OnDateSetting();
	afx_msg void OnSizeSetting();
	afx_msg void OnBySize();
	//}}AFX_MSG
	afx_msg LRESULT OnTrayNotification(WPARAM uID, LPARAM nMouseMsg);
#ifndef NO_FTP
	afx_msg LRESULT OnFTPConnect(WPARAM, LPARAM);
#endif
	afx_msg void OnTrayOpen();
	afx_msg void OnTrayExit();
	afx_msg void OnTrayBackup(UINT nID);
	afx_msg void OnTrayBrowse();
	afx_msg LRESULT OnBrowseFolder(WPARAM uID, LPARAM);
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ZCOPYDLG_H__3CE758A6_6C6E_11D1_A5E4_000000000000__INCLUDED_)
