// archiver.h : interface of the CArchiver class
//

#ifndef _ARCHIVER_H_
#define _ARCHIVER_H_

#include "UNLHA32.H"

#define M_OPEN_DEFAULT 0
#define M_SET_DEFAULT 0

class CArchiver
{
public:
	CArchiver();
	virtual ~CArchiver();

	void SetExtTable(LPCTSTR lpszExtTable = NULL);

	BOOL IsArchive(LPCTSTR lpszFileName) { return GetArcType(lpszFileName) != -1; }
	int GetArcType(LPCTSTR lpszFileName);
	BOOL LoadDll(LPCTSTR lpszFileName);
	void FreeDll();
	BOOL SetError(int result, LPCTSTR lpszFunc);

	HARC OpenArchive(HWND hWnd, LPCTSTR lpszArcName, UINT uMode = M_OPEN_DEFAULT);
	void CloseArchive();

	int FindFirst(LPCTSTR lpszWildName = NULL);
	int FindNext();
	LPCTSTR GetFileName(); // { return CA2W(m_info.szFileName); } ###_UNICODE
	int GetFileFolderLength();
	DWORD GetFileSize() { return m_info.dwOriginalSize; }
	DWORD GetFilePackedSize() { return m_info.dwCompressedSize; }
	WORD  GetFileRatio() { return m_info.wRatio; }
	WORD  GetFileDosDate() { return m_info.wDate; }
	WORD  GetFileDosTime() { return m_info.wTime; }
	void  GetFileTime(FILETIME& ft);
	WORD  GetFileDosAttr();
	DWORD GetFileAttributes();

	BOOL SetArchive(HWND hWnd, LPCTSTR lpszArcName, UINT uMode = M_SET_DEFAULT);
	BOOL Extract(LPCTSTR lpszFileName, LPCTSTR lpszDirName);
	BOOL ExtractAll(LPCTSTR lpszDirName);

private:
	HMODULE m_hDll;
	HARC m_hArc;
	int m_nArcType;
	DWORD m_dwError;
	LPCTSTR m_lpszExtTable;
	INDIVIDUALINFO m_info;
	HWND m_hWnd;
	TCHAR m_szArcName[MAX_PATH];
	TCHAR m_szExtractDir[MAX_PATH];
#ifdef _UNICODE
	TCHAR m_szFileName[FNAME_MAX32 + 1];
#endif

	enum ArcFunction {
		ARC_CMDLINE,
		ARC_GET_CURSOR_MODE,
		ARC_SET_CURSOR_MODE,

		ARC_OPEN_ARCHIVE,
		ARC_CLOSE_ARCHIVE,
		ARC_FIND_FIRST,
		ARC_FIND_NEXT,

		ARC_SET_OWNER_WINDOW_EX,
		ARC_KILL_OWNER_WINDOW_EX,
		ARC_PROC_MAX
	};

	FARPROC m_proc[ARC_PROC_MAX];
};

#endif //_ARCHIVER_H_
