/////////////////////////////////////////////////////////////////////////////
// base.cpp : implementation of Windows Base service utititlies

#include "stdafx.h"
#include "base.h"

CString GetErrorMessage(DWORD dwErr)
{
	LPVOID lpMsgBuf = NULL;
	CString sMsg;
	if(dwErr == 0) dwErr = GetLastError();
	int nErr = LOWORD(dwErr);
	TRACE(_T("Error=%d\n"), nErr);
	if(nErr == ERROR_INTERNET_EXTENDED_ERROR) {
		DWORD dwError;
		DWORD dwBufferSize;
		::InternetGetLastResponseInfo (&dwError, NULL, &dwBufferSize);
		if(dwBufferSize) {
			lpMsgBuf = MemAlloc(dwBufferSize);
			::InternetGetLastResponseInfo (&dwError, (LPTSTR)lpMsgBuf, &dwBufferSize);
			sMsg = CString((LPCTSTR)lpMsgBuf);
			MemFree(lpMsgBuf);
		}
	} else {
		if(nErr >= INTERNET_ERROR_BASE && nErr <= INTERNET_ERROR_LAST)
			::FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_HMODULE | FORMAT_MESSAGE_IGNORE_INSERTS,
				GetModuleHandle(_T("wininet.dll")), nErr, MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), (LPTSTR)&lpMsgBuf, 0, NULL );
		else
			::FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS, 
				NULL, dwErr, MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), (LPTSTR)&lpMsgBuf, 0, NULL );
		if(lpMsgBuf) {
			sMsg = CString((LPCTSTR)lpMsgBuf);
			::LocalFree(lpMsgBuf);	// ###1.04
		}
	}
	sMsg.TrimRight();	// ###1.23
	if(sMsg.IsEmpty())
//		sMsg.LoadString(DS_ERR_UNKNOWN);
		sMsg = _T("Unknown error");
	return sMsg;
}

typedef BOOL(WINAPI*LPGETDISKFREESPACEEX)(LPCTSTR, PULARGE_INTEGER, PULARGE_INTEGER, PULARGE_INTEGER);

//		m_lpJre2Open = (LPJRE2OPEN)GetProcAddress(m_hDll, _T("Jre2Open"));

BOOL GetDriveInfo(LPCTSTR pPath, LPDWORD pTotalClusters, LPDWORD pFreeClusters, LPDWORD pBytesPerCluster)
{
	DWORD dwSectorsPerCluster = 0;
	DWORD dwBytesPerSector = 0;
	DWORD dwFreeClusters;
	DWORD dwTotalClusters;

	if(!::GetDiskFreeSpace(pPath, &dwSectorsPerCluster, &dwBytesPerSector, &dwFreeClusters, &dwTotalClusters))
		return FALSE;
	DWORD dwBytesPerCluster = dwBytesPerSector * dwSectorsPerCluster;
	if(dwBytesPerCluster == 0) return FALSE;
	if(pBytesPerCluster)
		*pBytesPerCluster = dwBytesPerCluster;
	if(!pTotalClusters && !pFreeClusters) return TRUE;
	if(pTotalClusters)
		*pTotalClusters = dwTotalClusters;
	if(pFreeClusters)
		*pFreeClusters = dwFreeClusters;

	BOOL bResult = TRUE;
	HINSTANCE hModule = ::LoadLibrary(_T("KERNEL32.DLL"));

#ifndef _UNICODE
#define API_GetDiskFreeSpaceEx "GetDiskFreeSpaceExA"
#else
#define API_GetDiskFreeSpaceEx "GetDiskFreeSpaceExW"
#endif

	if(hModule) {
		LPGETDISKFREESPACEEX pGetDiskFreeSpaceEx = (LPGETDISKFREESPACEEX)GetProcAddress(hModule, API_GetDiskFreeSpaceEx);
		if(pGetDiskFreeSpaceEx) {
			ULARGE_INTEGER qFreeBytesAvailableToCaller;
			ULARGE_INTEGER qTotalNumberOfBytes;
			ULARGE_INTEGER qTotalNumberOfFreeBytes;
			if(pGetDiskFreeSpaceEx(pPath, &qFreeBytesAvailableToCaller, &qTotalNumberOfBytes, &qTotalNumberOfFreeBytes)) {
				if(pTotalClusters)
					*pTotalClusters = (DWORD)(qTotalNumberOfBytes.QuadPart / dwBytesPerCluster);
				if(pFreeClusters)
					*pFreeClusters = (DWORD)(qTotalNumberOfFreeBytes.QuadPart / dwBytesPerCluster);
			} else
				bResult = FALSE;	// ###1.04
		}
		::FreeLibrary(hModule);
	}
	return bResult;
}

BOOL GetDriveInfoString(LPCTSTR pPath, CString& sTotal, CString& sFree, LPDWORD pBytesPerCluster)
{
	DWORD dwTotalClusters;
	DWORD dwFreeClusters;
	DWORD dwBytesPerCluster;
	if(!GetDriveInfo(pPath, &dwTotalClusters, &dwFreeClusters, &dwBytesPerCluster))
		return FALSE;
	sTotal = FormatHugeValue(dwTotalClusters, dwBytesPerCluster);
	sFree  = FormatHugeValue(dwFreeClusters, dwBytesPerCluster);
	if(pBytesPerCluster)
		*pBytesPerCluster = dwBytesPerCluster;
	return TRUE;
}

CString FormatHugeValue(DWORD dwSize, DWORD dwBase)
{
	DWORD dwDenom = 1024 * 1024 / dwBase;
	if(dwDenom == 0) return CString(_T(""));
	DWORD dwResult = dwSize / dwDenom;
	CString sUnit = _T("MB");
	if(dwResult == 0) {
		dwResult = ::MulDiv(dwSize, dwBase, 1024);
		if(dwResult)
			sUnit = _T("KB");

	}
	return SeparateByComma(dwResult) + sUnit;
}

CString SeparateByComma(DWORDLONG num)
{
	CString sSrc; sSrc.Format(_T("%I64u"), num);
	TCHAR sDst[64];
	int n = sSrc.GetLength();
	LPCTSTR src = sSrc;
	LPTSTR dst = sDst;
	do {
		*dst++ = *src++; n--;
		if(!(n % 3) && n) *dst++ = ',';
	} while(n > 0);
	*dst++ = '\0';
	return sDst;
}

