/////////////////////////////////////////////////////////////////////////////
// Call Browser

int CALLBACK BrowseCallbackProc(HWND hwnd, UINT uMsg, LPARAM lParam, LPARAM lpData)
{
	TCHAR sDir[MAX_PATH];
	switch(uMsg) {
	case BFFM_INITIALIZED:
		SendMessage(hwnd, BFFM_SETSELECTION, TRUE, lpData);
		break;
	case BFFM_SELCHANGED:
		if (SHGetPathFromIDList((LPITEMIDLIST) lParam, sDir))
			SendMessage(hwnd, BFFM_SETSTATUSTEXT, 0, (LPARAM)sDir);
		break;
	}
	return 0;
}

CString ShellBrowseFolder(LPCTSTR pPath, LPCTSTR pTitle)
{
	CString sPath;
	LPMALLOC pMalloc;
	if(SUCCEEDED(SHGetMalloc(&pMalloc))) {
		BROWSEINFO bi;
		ZeroMem(bi);
		bi.hwndOwner = AfxGetMainWnd()->GetSafeHwnd();
		bi.ulFlags = BIF_RETURNONLYFSDIRS | BIF_STATUSTEXT;
		bi.lpszTitle = pTitle;
		bi.lpfn = BrowseCallbackProc;
		bi.lParam = (LPARAM)pPath;
		LPITEMIDLIST pidl = SHBrowseForFolder(&bi);
		if(pidl) {
			TCHAR szDir[MAX_PATH];
			if (SHGetPathFromIDList(pidl, szDir))
				sPath = CString(szDir);
			pMalloc->Free(pidl);
		}
		pMalloc->Release();
	}
	return sPath;
}
