// options.cpp : implementation of the COptions class
//

#include "stdafx.h"
#include "options.h"

static const TCHAR sRegDefault[] = _T("Settings");
static const TCHAR sRegHistory[] = _T("History");

COptions::COptions()
{
	m_bModified = FALSE;
	SetSection();
}

void COptions::SetSection(LPCTSTR lpszSection)
{
	m_lpszSection = lpszSection ? lpszSection : sRegDefault;
}

UINT COptions::GetProfileInt(LPCTSTR lpszEntry, int nDefault)
{
	return AfxGetApp()->GetProfileInt(m_lpszSection, lpszEntry, nDefault);
}

BOOL COptions::WriteProfileInt(LPCTSTR lpszEntry, int nValue)
{
	return AfxGetApp()->WriteProfileInt(m_lpszSection, lpszEntry, nValue);
}

CString COptions::GetProfileString(LPCTSTR lpszEntry, LPCTSTR lpszDefault)
{
	return AfxGetApp()->GetProfileString(m_lpszSection, lpszEntry, lpszDefault);
}

BOOL COptions::WriteProfileString(LPCTSTR lpszEntry, LPCTSTR lpszValue)
{
	return AfxGetApp()->WriteProfileString(m_lpszSection, lpszEntry, lpszValue);
}

BOOL COptions::GetProfileBinary(LPCTSTR lpszEntry, LPVOID pData, UINT nBytes)
{
	LPBYTE pBuffer;
	UINT nBytes1;
	if(AfxGetApp()->GetProfileBinary(m_lpszSection, lpszEntry, &pBuffer, &nBytes1)) {
		if(nBytes && nBytes != nBytes1) {	// ###1.24
			delete pBuffer;
		} else {
			memcpy(pData, pBuffer, nBytes1);
			delete pBuffer;
			return TRUE;
		}
	}
	return FALSE;
}

BOOL COptions::WriteProfileBinary(LPCTSTR lpszEntry, LPBYTE pData, UINT nBytes)
{
	return AfxGetApp()->WriteProfileBinary(m_lpszSection, lpszEntry, pData, nBytes);
}

void COptions::LoadHistory(CString sHistName, CStringArray& sArrHist)
{
	CWinApp* pApp = AfxGetApp();
	for_to(i, (int)pApp->GetProfileInt(sRegHistory, sHistName + _T("Count"), 0)) {
		CString sRegKey;
		sRegKey.Format(sHistName + _T("%d"), i+1);
		CString sHist = pApp->GetProfileString(sRegHistory, sRegKey);
		if(!sHist.IsEmpty())
			sArrHist.Add(sHist);
	}
}

void COptions::SaveHistory(CString sHistName, CStringArray& sArrHist)
{
	CWinApp* pApp = AfxGetApp();
	pApp->WriteProfileInt(sRegHistory, sHistName + _T("Count"), sArrHist.GetSize());
	for_to(i, sArrHist.GetSize()) {
		CString sRegKey;
		sRegKey.Format(sHistName + _T("%d"), i+1);
		pApp->WriteProfileString(sRegHistory, sRegKey, sArrHist[i]);
	}
}

