/////////////////////////////////////////////////////////////////////////////
// pidl.cpp : PIDL manipulation helper

#include "stdafx.h"
#include "pidl.h"
#include <afxpriv.h>

LPMALLOC g_pMalloc = NULL;

int GetFolderIcon(LPITEMIDLIST pIDL, UINT uFlags)
{	
	SHFILEINFO sfi;
	ZeroMem(sfi);
	::SHGetFileInfo((LPCTSTR)pIDL, 0, &sfi, sizeof(SHFILEINFO), uFlags | SHGFI_PIDL| SHGFI_SYSICONINDEX);
	return sfi.iIcon;
}

int GetFolderIcon(LPCTSTR pPath, UINT uFlags)
{	
	SHFILEINFO sfi;
	ZeroMem(sfi);
	::SHGetFileInfo(pPath, 0, &sfi, sizeof(SHFILEINFO), uFlags | SHGFI_SYSICONINDEX);
	return sfi.iIcon;
}

int GetFolderIcon(LPCTSTR pPath, DWORD dwAttr, UINT uFlags)
{
	if(!pPath) pPath = _T("C:\\TEMP");	// ??? 
	SHFILEINFO sfi;
	ZeroMem(sfi);
	::SHGetFileInfo(pPath, dwAttr, &sfi, sizeof(SHFILEINFO), uFlags | SHGFI_USEFILEATTRIBUTES | SHGFI_SYSICONINDEX);
	return sfi.iIcon;
}

UINT GetFolderAttr(LPITEMIDLIST pIDL)
{
	SHFILEINFO sfi;
	ZeroMem(sfi);
	::SHGetFileInfo((LPCTSTR)pIDL, 0, &sfi, sizeof(SHFILEINFO), SHGFI_ATTRIBUTES | SHGFI_PIDL);
	return sfi.dwAttributes;
}

UINT GetFolderAttr(LPCTSTR pPath)
{
	SHFILEINFO sfi;
	ZeroMem(sfi);
	::SHGetFileInfo(pPath, 0, &sfi, sizeof(SHFILEINFO), SHGFI_ATTRIBUTES);
	return sfi.dwAttributes;
}

CString GetNameOf(LPSHELLFOLDER pSF, LPITEMIDLIST pIDL, DWORD dwFlags)
{
//	BOOL bResult = FALSE;
	STRRET str;
	CString sTemp;
	LPTSTR pBuff = sTemp.GetBuffer(MAX_PATH);
	if(pSF->GetDisplayNameOf(pIDL, dwFlags, &str) == NOERROR) {
		StrRetToBuf(&str, pIDL, pBuff, MAX_PATH); // ###_UNICODE
/*		switch(str.uType)
		{
		case STRRET_WSTR:
			bResult = WideCharToMultiByte(CP_OEMCP, 0, str.pOleStr, -1, pBuff, MAX_PATH, NULL, NULL);
			break;
		case STRRET_OFFSET:
			strcpy(pBuff, (LPSTR)pIDL + str.uOffset);
			bResult = TRUE;
			break;
		case STRRET_CSTR:
			strcpy(pBuff, (LPSTR)str.cStr);
			bResult = TRUE;
			break;
		}*/
	}
	sTemp.ReleaseBuffer();
	return sTemp;
}

CString GetPathFromPIDL(LPITEMIDLIST pIDL) // ###1.24
{
	CString sPath;
	::SHGetPathFromIDList(pIDL, sPath.GetBuffer(MAX_PATH));
	sPath.ReleaseBuffer();
	return sPath;
}

LPITEMIDLIST GetPIDLOf(LPSHELLFOLDER pSF, LPCTSTR pPath)
{
	LPITEMIDLIST pIDL;
	ULONG uEaten, dwAttr;
	USES_CONVERSION;
#ifndef _UNICODE
	if (pSF->ParseDisplayName(AfxGetMainWnd()->m_hWnd, NULL, A2W(pPath), &uEaten, &pIDL, &dwAttr) == NOERROR)
#else
	if (pSF->ParseDisplayName(AfxGetMainWnd()->m_hWnd, NULL, (LPTSTR)pPath, &uEaten, &pIDL, &dwAttr) == NOERROR)
#endif
		return pIDL;
	return NULL;
}

UINT GetPIDLSize(LPCITEMIDLIST pIDL)
{
	UINT cbTotal = 0;
	if(pIDL) {
		cbTotal += sizeof(pIDL->mkid.cb);
		while(pIDL->mkid.cb) {
			cbTotal += pIDL->mkid.cb;
			pIDL = (LPCITEMIDLIST)(((LPSTR)pIDL) + pIDL->mkid.cb);
		}
	}
	return cbTotal;
}

static LPITEMIDLIST NewPIDL(UINT cbSize)
{
	LPITEMIDLIST pIDL = NULL;
	pIDL = (LPITEMIDLIST)g_pMalloc->Alloc(cbSize);
	if(pIDL)
		memset(pIDL, 0, cbSize);
	return pIDL;
}

LPITEMIDLIST ConcatPIDLs(LPCITEMIDLIST pIDL1, LPCITEMIDLIST pIDL2)
{
	UINT cb1 = pIDL1 ? GetPIDLSize(pIDL1) - sizeof(pIDL1->mkid.cb) : 0;
	UINT cb2 = GetPIDLSize(pIDL2);
	LPITEMIDLIST pIDLNew = NewPIDL(cb1 + cb2);
	if(pIDLNew) {
		if(pIDL1)
			memcpy(pIDLNew, pIDL1, cb1);
		memcpy(((LPSTR)pIDLNew) + cb1, pIDL2, cb2);
	}
	return pIDLNew;
}

LPCITEMIDLIST GetLastPIDL(LPCITEMIDLIST pIDL)
{
	LPCITEMIDLIST pIDLLast = pIDL;
	while(pIDL->mkid.cb) {
		pIDLLast = pIDL;
		pIDL = (LPCITEMIDLIST)(((LPSTR)pIDL) + pIDL->mkid.cb);
	}
	return pIDLLast;
}

LPITEMIDLIST GetSubPIDL(LPCITEMIDLIST pIDLtop, int nIndex)
{
//	pIDLtop = (LPCITEMIDLIST)(((LPSTR)pIDLtop) + pIDLtop->mkid.cb);
	LPCITEMIDLIST pIDL = pIDLtop;
	do {
		pIDL = (LPCITEMIDLIST)(((LPSTR)pIDL) + pIDL->mkid.cb);
		if(pIDL == 0) return NULL;
	} while(nIndex--);
	DWORD size = (LPSTR)pIDL - (LPSTR)pIDLtop;
	LPITEMIDLIST pIDLNew = NewPIDL(size + 2);
	memcpy(pIDLNew, pIDLtop, size);
	return pIDLNew;
}

HIMAGELIST GetShellImageList(UINT uFlags)
{
	SHFILEINFO sfi;
	return (HIMAGELIST)SHGetFileInfo((LPCTSTR)_T("C:\\"),	// ??? 
			0, &sfi, sizeof(SHFILEINFO), SHGFI_SYSICONINDEX | uFlags);
}

int ComparePIDs(LPSHELLFOLDER pSF, LPCITEMIDLIST pIDL1, LPCITEMIDLIST pIDL2)
{
	HRESULT hResult = pSF->CompareIDs(0, pIDL1, pIDL2);
	if(SUCCEEDED(hResult))
	    return (short)SCODE_CODE(GetScode(hResult));
	else
		return 0;
}

// ###1.20

int GetPIDLLength(LPCITEMIDLIST pIDL)
{
	int nCount = 0;
	if(pIDL) {
		while(pIDL->mkid.cb) {
			nCount++;
			pIDL = (LPCITEMIDLIST)(((LPSTR)pIDL) + pIDL->mkid.cb);
		}
	}
	return nCount;
}

LPSHELLFOLDER BindToPath(LPSHELLFOLDER pSFRoot, LPCTSTR pPathParent) // ###1.24
{
	LPSHELLFOLDER pSFParent = NULL;
	LPITEMIDLIST pIDLParent;
	if(pIDLParent = GetPIDLOf(pSFRoot, pPathParent)) {
		pSFRoot->BindToObject(pIDLParent, NULL, IID_IShellFolder, (LPVOID *)&pSFParent);
		g_pMalloc->Free(pIDLParent);
	}
	return pSFParent;
}

